      SUBROUTINE initializePDFs(eta1,eta2,muF,order)
      implicit none
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order
      CHARACTER prefix*50
      include 'Commons/common-pdfvals.f'

      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      eta1_of_init_PDFs = eta1
      eta2_of_init_PDFs = eta2

      PDFbbbar = bot1*bbar2 + bot2*bbar1
      PDFgb = glu1*(bbar2+bot2)
      PDFbg = (bot1+bbar1)*glu2
      PDFgg = glu1*glu2
      PDFbb = bot1*bot2 + bbar1*bbar2
      PDFqb = (up1+ubar1+dn1+dbar1+str1+sbar1+chm1+cbar1)*(bot2+bbar2)
      PDFbq = (up2+ubar2+dn2+dbar2+str2+sbar2+chm2+cbar2)*(bot1+bbar1)
      PDFqq = (up1*ubar2 + up2*ubar1) + (dn1*dbar2 + dn2*dbar1)
     f       + (str1*sbar2 + str2*sbar1) + (chm1*cbar2 + chm2*cbar1)
      IF(pp == 0) THEN
         PDFbbbar = bot1*bot2 + bbar2*bbar1
         PDFbb = bot1*bbar2 + bbar1*bot2
         PDFqq = up1*up2 + ubar2*ubar1 + dn1*dn2 +
     f   dbar2*dbar1 + str1*str2 + sbar2*sbar1 + chm1*chm2 + cbar2*cbar1
      ENDIF
      END

************** PDFS ***************************************
      DOUBLE PRECISION FUNCTION PDFsgg(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFsgg=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsgg = glu1*glu2
      END

      DOUBLE PRECISION FUNCTION PDFsgq(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFsgq=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsgq=(up2+ubar2+dn2+dbar2+str2+sbar2+chm2+cbar2+bot2+bbar2)*glu1
      END

      DOUBLE PRECISION FUNCTION PDFsqg(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFsqg=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsqg=(up1+ubar1+dn1+dbar1+str1+sbar1+chm1+cbar1+bot1+bbar1)*glu2
      END

      DOUBLE PRECISION FUNCTION PDFsqqbar(eta1,eta2,muF,order)
      implicit none
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order
      include 'Commons/common-pdfvals.f'

      PDFsqqbar=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsqqbar = PDFsqqbar + (up1*ubar2 + up2*ubar1)
      PDFsqqbar = PDFsqqbar + (dn1*dbar2 + dn2*dbar1)
      PDFsqqbar = PDFsqqbar + (str1*sbar2 + str2*sbar1)
      PDFsqqbar = PDFsqqbar + (chm1*cbar2 + chm2*cbar1)
      PDFsqqbar = PDFsqqbar + (bot1*bbar2 + bot2*bbar1)
      IF(pp == 0) PDFsqqbar = up1*up2 + ubar2*ubar1 + dn1*dn2 +
     f dbar2*dbar1 + str1*str2 + sbar2*sbar1 + chm1*chm2 + cbar2*cbar1 +
     f bot1*bot2+bbar1*bbar2
      END      


      DOUBLE PRECISION FUNCTION PDFsbbbar(eta1,eta2,muF,order)
      implicit none
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order
      CHARACTER prefix*50
      include 'Commons/common-pdfvals.f'

      PDFsbbbar=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsbbbar = bot1*bbar2 + bot2*bbar1
      IF(pp == 0) PDFsbbbar = bot1*bot2 + bbar2*bbar1
      END
      

      DOUBLE PRECISION FUNCTION PDFsgb(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order
      PDFsgb=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsgb = glu1*(bbar2+bot2)
      END

      DOUBLE PRECISION FUNCTION PDFsbg(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFsbg=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsbg = (bot1+bbar1)*glu2
      END

      DOUBLE PRECISION FUNCTION PDFsbb(eta1,eta2,muF,order)
      implicit none
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order
      include 'Commons/common-pdfvals.f'

      PDFsbb=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsbb = bot1*bot2 + bbar1*bbar2
      IF(pp == 0) PDFsbb = bot1*bbar2 + bbar1*bot2
      END

      DOUBLE PRECISION FUNCTION PDFsqb(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFsqb=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFsqb = (up1+ubar1+dn1+dbar1+str1+sbar1+chm1+cbar1)*(bot2
     &     +bbar2)
      END
      
!         u : 0.286608d0
!         d : 0.369485d0
      DOUBLE PRECISION FUNCTION PDFshiggstr(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFshiggstr=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFshiggstr=PDFshiggstr+ 0.369485d0 * (
     &       dn1*dbar2 + dn2*dbar1
     &     + str1*sbar2 + str2*sbar1
     &     + bot1*bbar2 + bot2*bbar1)

      PDFshiggstr=PDFshiggstr+ 0.286608d0 * (
     &     up1*ubar2 + up2*ubar1 + chm1*cbar2 + chm2*cbar1 )
      END
      
      DOUBLE PRECISION FUNCTION PDFshiggstrqg(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFshiggstrqg=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFshiggstrqg=PDFshiggstrqg+ 0.369485d0 * (
     &     (dn1 + dbar1 + str1 + sbar1 + bot1+bbar1)*glu2 )
      
      PDFshiggstrqg=PDFshiggstrqg+ 0.286608d0 * (
     &     (up1 + ubar1 + chm1 + cbar1)*glu2 )
      END
      
      DOUBLE PRECISION FUNCTION PDFshiggstrgq(eta1,eta2,muF,order)
      implicit none
      real*8 dn1,dbar1,up1,ubar1,str1,sbar1,chm1,cbar1,bot1,bbar1,glu1
      real*8 dn2,dbar2,up2,ubar2,str2,sbar2,chm2,cbar2,bot2,bbar2,glu2
      DOUBLE PRECISION eta1,eta2,muF
      INTEGER order

      PDFshiggstrgq=0d0
      IF(eta1>1d0) RETURN
      IF(eta2>1d0) RETURN

      call pdfs(eta1,muF,up1,ubar1,dn1,dbar1,str1,sbar1,chm1,cbar1
     &     ,bot1,bbar1,glu1)
      call pdfs(eta2,muF,up2,ubar2,dn2,dbar2,str2,sbar2,chm2,cbar2
     &     ,bot2,bbar2,glu2)

      PDFshiggstrgq=PDFshiggstrgq+ 0.369485d0 * (
     &     (dn2 + dbar2 + str2 + sbar2 + bot2 + bbar2)*glu1 )
      
      PDFshiggstrgq=PDFshiggstrgq+ 0.286608d0 * (
     &     (up2 + ubar2 + chm2 + cbar2)*glu1 )
      END
      

