com-- 
com-- Subroutines to print ERROR-, WARNING- or INFO-Messages.
com-- 
C-{{{ SUBROUTINE printstop:

      SUBROUTINE printstop(str)
      implicit none
      CHARACTER*(*) str
      INTEGER length
      length = len(str)
      write(*,*) 'MoRe-SusHi (error): ',str(1:min(52,length))
      IF(52 < length)
     fwrite(*,*) '                ..  ',str(53:min(103,length))
      IF(103 < length)
     fwrite(*,*) '                ..  ',str(104:min(155,length))
      IF(154 < length)
     fwrite(*,*) '                ..  ',str(156:min(207,length))
      IF(206 < length)
     fwrite(*,*) '                ..  ',str(208:min(260,length))
      write(*,*) '                ..  ------   Program stopped  -------'
      write(*,*)
                  
      write(40,*) 'MoRe-SusHi (error): ',str(1:min(52,length))
      IF(52 < length)
     fwrite(40,*) '                ..  ',str(53:min(103,length))
      IF(103 < length)
     fwrite(40,*) '                ..  ',str(104:min(155,length))
      IF(154 < length)
     fwrite(40,*) '                ..  ',str(156:min(207,length))
      IF(206 < length)
     fwrite(40,*) '                ..  ',str(208:min(260,length))
      write(40,*)'                ..  ------   Program stopped  -------'
      write(40,*)
      stop
      END

C-}}}
C-{{{ SUBROUTINE printwarn:

      SUBROUTINE printwarn(str)
      implicit none
      CHARACTER*(*) str
      INTEGER length
      length = len(str)
      write(*,*) 'MoRe-SusHi (warning): ',str(1:min(51,length))
      IF(51 < length)
     fwrite(*,*) '                  ..  ',str(52:min(103,length))
      IF(103 < length)
     fwrite(*,*) '                  ..  ',str(104:min(155,length))
      IF(154 < length)
     fwrite(*,*) '                  ..  ',str(156:min(207,length))
      IF(206 < length)
     fwrite(*,*) '                  ..  ',str(208:min(260,length))

      write(40,*) 'MoRe-SusHi (warning): ',str(1:min(51,length))
      IF(51 < length)
     fwrite(40,*) '                  ..  ',str(52:min(103,length))
      IF(103 < length)
     fwrite(40,*) '                  ..  ',str(104:min(155,length))
      IF(154 < length)
     fwrite(40,*) '                  ..  ',str(156:min(207,length))
      IF(206 < length)
     fwrite(40,*) '                  ..  ',str(208:min(260,length))
      END

C-}}}
C-{{{ SUBROUTINE printinfo:

      SUBROUTINE printinfo(str)
      implicit none
      CHARACTER*(*) str
      INTEGER length
      length = len(str)
      write(*,*) 'MoRe-SusHi (info): ',str(1:min(53,length))
      IF(53 < length)
     fwrite(*,*) '               ..  ',str(54:min(106,length))
      IF(106 < length)
     fwrite(*,*) '               ..  ',str(107:min(159,length))
      IF(159 < length)
     fwrite(*,*) '               ..  ',str(160:min(212,length))
      IF(213 < length)
     fwrite(*,*) '               ..  ',str(213:min(275,length))

      write(40,*) 'MoRe-SusHi (info): ',str(1:min(53,length))
      IF(53 < length)
     fwrite(40,*) '               ..  ',str(54:min(106,length))
      IF(106 < length)
     fwrite(40,*) '               ..  ',str(107:min(159,length))
      IF(159 < length)
     fwrite(40,*) '               ..  ',str(160:min(212,length))
      IF(213 < length)
     fwrite(40,*) '               ..  ',str(213:min(275,length))
      END

C-}}}

com-- 
com-- Function returns name of algorithm associated to numerical value
com--
C-{{{ FUNCTION getalgorithm:

      CHARACTER*11 FUNCTION getalgorithm(algorithm)
      INTEGER algorithm
      IF(algorithm == 1) getalgorithm = 'W-Scheme'
      IF(algorithm == 2) getalgorithm = 'Jade-Scheme'
      IF(algorithm == 3) getalgorithm = 'long-kT'
      IF(algorithm == 4) getalgorithm = 'anti-kT'
      END

C-}}}

com-- 
com-- Subroutine to integrate cross sections over different phase-spaces
com-- 
C-{{{ SUBROUTINE integrate:

      SUBROUTINE integrate(func,intvars,ncalls,itmxs,int,err,chi2)
      DOUBLE PRECISION int,err
      INTEGER intvars,ncalls,itmxs
      include 'Commons/common-vegas.f'
      EXTERNAL func

      acc = -1d0
      nprn = 0       ! set how much info vegas give (try 1 or -1)

      ndim = intvars ! number of integration variables
      ncall=ncalls
      itmx=itmxs

      XL(1) = 0.00000000001d0
      XL(2) = 0.00000000001d0
      XL(3) = 0.00000000001d0!-0.99999999999d0
      XL(4) = 0.00000000001d0
      XL(5) = 0.00000000001d0
      XL(6) = 0.00000000001d0
      XU(1) = 0.99999999999d0
      XU(2) = 0.99999999999d0
      XU(3) = 0.99999999999d0
      XU(4) = 0.99999999999d0
      XU(5) = 0.99999999999d0
      XU(6) = 0.99999999999d0
      IF(intvars == 6) XL(3) = 0.00000000001d0

com-- 
com-- intvars = 11 --> logrithms for resummation int_0^inf
com-- 
      IF(intvars == 11) THEN
         ndim = 1
         XL(1) = 0d0
         XU(1) = 99d0        
      ENDIF

      IF(intvars == 12) THEN
         ndim = 1
         XL(1) = 0d0
         XU(1) = dsqrt(300.d0)
      ENDIF

      CALL vegas(func,int,err,chi2)
      END

C-}}}            
com-- 
com-- Subroutine to do Lorentstransformation of momenta
com-- in 2 -> 2 process.
com-- 
C-{{{ SUBROUTINE LorentzTrafo2:

      SUBROUTINE LorentzTrafo2(PiTrafo,PfTrafo,Pi,Pf)
      DOUBLE PRECISION PiTrafo(4,3),PfTrafo(4,3),Pi(4,3),Pf(4,3)
     f ,beta,Eprime,gamma
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-fraction.f'

      beta=(eta2-eta1)/(eta1+eta2)
      Eprime=E/dsqrt(eta1*eta2)
      gamma=1/dsqrt(1-beta**2)

      PiTrafo(4,1)=eta1*Eprime
      PiTrafo(1,1)=0d0
      PiTrafo(2,1)=0d0
      PiTrafo(3,1)=eta1*Eprime

      PiTrafo(4,2)=eta2*Eprime
      PiTrafo(1,2)=0d0
      PiTrafo(2,2)=0d0
      PiTrafo(3,2)=-eta2*Eprime

      PfTrafo(4,1)= gamma *(Pf(4,1)-beta*Pf(3,1))
      PfTrafo(1,1)= Pf(1,1)
      PfTrafo(2,1)= Pf(2,1)
      PfTrafo(3,1)= gamma *(Pf(3,1)-beta*Pf(4,1))
      
      PfTrafo(4,2)= gamma *(Pf(4,2)-beta*Pf(3,2))
      PfTrafo(1,2)= Pf(1,2)
      PfTrafo(2,2)= Pf(2,2)
      PfTrafo(3,2)= gamma *(Pf(3,2)-beta*Pf(4,2))
      END

C-}}}
com-- 
com-- Subroutine to do Lorentstransformation of momenta
com-- in 2 -> 3 process.
com-- 
C-{{{ SUBROUTINE LorentzTrafo3:

      SUBROUTINE LorentzTrafo3(PiTrafo,PfTrafo,Pi,Pf)
      DOUBLE PRECISION PiTrafo(4,3),PfTrafo(4,3),Pi(4,3),Pf(4,3)
     f ,beta,Eprime,gamma
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-fraction.f'

      beta=(eta2-eta1)/(eta1+eta2)
      Eprime=dsqrt(Shad)/2d0
      gamma=1d0/dsqrt(1-beta**2)

      PiTrafo(4,1)=eta1*Eprime
      PiTrafo(1,1)=0d0
      PiTrafo(2,1)=0d0
      PiTrafo(3,1)=eta1*Eprime
      
      PiTrafo(4,2)=eta2*Eprime
      PiTrafo(1,2)=0d0
      PiTrafo(2,2)=0d0
      PiTrafo(3,2)=-eta2*Eprime

      PiTrafo(1,3)=0d0
      PiTrafo(2,3)=0d0
      PiTrafo(3,3)=0d0
      PiTrafo(4,3)=0d0

      PfTrafo(4,1)= gamma *(Pf(4,1)-beta*Pf(3,1))
      PfTrafo(1,1)= Pf(1,1)
      PfTrafo(2,1)= Pf(2,1)
      PfTrafo(3,1)= gamma *(Pf(3,1)-beta*Pf(4,1))

      PfTrafo(4,2)= gamma *(Pf(4,2)-beta*Pf(3,2))
      PfTrafo(1,2)= Pf(1,2)
      PfTrafo(2,2)= Pf(2,2)
      PfTrafo(3,2)= gamma *(Pf(3,2)-beta*Pf(4,2))

      PfTrafo(4,3)= gamma *(Pf(4,3)-beta*Pf(3,3))
      PfTrafo(1,3)= Pf(1,3)
      PfTrafo(2,3)= Pf(2,3)
      PfTrafo(3,3)= gamma *(Pf(3,3)-beta*Pf(4,3))

      END

C-}}}
com-- 
com-- Splitting functions
com-- 
C-{{{ FUNCTION P:_qq

      DOUBLE PRECISION FUNCTION P_qq(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_qq=cF*(1+z**2)/(1-z)  ! +3d0/2d0*delta(1-z)
      END

C-}}}
C-{{{ FUNCTION P:_qg

      DOUBLE PRECISION FUNCTION P_qg(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_qg=cF*(1+(1-z)**2)/z
      END

C-}}}
C-{{{ FUNCTION P:_gq

      DOUBLE PRECISION FUNCTION P_gq(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_gq=tR*(1-(2*z*(1-z)))
!       P_gq=tR*(z**2+(1-z)**2)
      END

C-}}}
C-{{{ FUNCTION P:_gg_const

      DOUBLE PRECISION FUNCTION P_gg_const(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_gg_const = 2d0*cA * ((1-z)/z-1+z*(1-z)) ! +beta0 delta(1-z)
      END

C-}}}
C-{{{ FUNCTION P:_gg_plus

      DOUBLE PRECISION FUNCTION P_gg_plus(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_gg_plus = 2d0*cA * 1/(1-z) ! +beta0 delta(1-z)
      END

C-}}}
C-{{{ FUNCTION P:_gg_delta

      DOUBLE PRECISION FUNCTION P_gg_delta(z)
      implicit none
      DOUBLE PRECISION z
      include 'Commons/common-constants.f'
      P_gg_delta = beta0
      END

C-}}}
com-- 
com-- 4-Vector product
com-- 
C-{{{ FUNCTION dot:

      DOUBLE PRECISION FUNCTION dot(T,x,K,y)
      DOUBLE PRECISION T(4,3)
      DOUBLE PRECISION K(4,3)
      INTEGER x, y
      dot=T(4,x)*K(4,y)-T(1,x)*K(1,y)-T(2,x)*K(2,y)-T(3,x)*K(3,y)
      RETURN
      END

C-}}}
com-- 
com-- Heaviside theta function
com-- 
C-{{{ FUNCTION theta:

      DOUBLE PRECISION FUNCTION theta(x,eta)
      DOUBLE PRECISION x,eta
      theta=0d0
      IF(x>=eta) theta=1d0
      END

C-}}}
C-{{{ FUNCTION Htheta:

      DOUBLE PRECISION FUNCTION Htheta(x)
      DOUBLE PRECISION x
      Htheta=0d0
      IF(x >= 0d0) Htheta=1d0
      END

C-}}}
com-- 
com-- Returns length of string (without blanks)
com-- 
C-{{{ function strlen:

      integer function strlen(st)
      integer		i
      character		st*(*)
      i = len(st)
      do while (st(i:i) .eq. ' ')
        i = i - 1
      enddo
      strlen = i
      return
      end

C-}}}
