com-- These Routines were taken from HqT and modified for our purposes.
com-- G. Bozzi, S. Catani, D. de Florian, M. Grazzini
com-- Phys. Lett. B564 (2003) 65 [hep-ph/0302104]
com-- Nucl. Phys. B737 (2006) 73 [hep-ph/0508068]    

!     ord_in:   1(NLL)/2(NNLL)
!     in_state: 1(gg)/2(qq)
      SUBROUTINE get_resummed(ord_in,resummed,res_err)
      implicit none
      logical NEWA3
      character name*64
      character*64 runstring
      integer j,ifail,flag,flag1,flag2,flag4,flagalphas,imod
      integer ih1,ih2,inorm,icoll,nset,mem,channel,cicle
      integer isetproton,ippbar,nloop,iord,flagrealcomplex
      real *8 v,fu,fd,max,min,tmp1,tmp2,xlam,phi,abisq
      real *8 errest,adpint,sigma0,gevpb,gf,amt,xmb,amh,factor
      real *8 arg1,arg2,aass
      real *8 integral
      real *8 subqqb,subqg,subgg,a_param,b0p,resummscale
      complex *16 S,ru,rd,rr,jac
      complex *16 alphs
      real *8 allres,expres,ris,matched,switched,g,LT
      real *8 qtmin,qtmax,qtbin
      real *8 dg2,Gamma2g,dq2,Gamma2q
      INTEGER ord_in,pdforder,verbose
      DOUBLE PRECISION resummed,res_err,Hbb,AMPLO

c.....this is for LL calculation
      complex *16 qqb1,qg1,gg1,LLgg
      common/LLgg/LLgg
      common/runstring/runstring

      common/gf/gf
      common/flagrealcomplex/flagrealcomplex
      common/aass/aass
      common/v/v
      common/nloop/nloop
      common/order_hqt/iord
      common/jac/jac
      common/j/j
      common/isetproton/isetproton
      common/flag/flag
      common/flag1/flag1
      common/flag2/flag2
      common/flag4/flag4
      common/flagalphas/flagalphas
      common/xlam/xlam
      common/ippbar/ippbar
      common/modified/imod
      common/a_param/a_param,b0p
      common/sigma0/sigma0
      common/amt/amt
      common/xmb/xmb
      common/NP/g
      common/nset/nset
      common/LT/LT
      common/channel/channel
      common/pdf/ih1,ih2
      common/PDFname/name,pdforder
      common/mem/mem
      COMMON /verbose/ verbose
       real *8 qt,qt2,xtau,q,q2,shad_hqt,sroot,mur,mur2,muf_hqt,muf2
       common/scale/qt,qt2,xtau,q,q2,shad_hqt,sroot,mur,mur2,muf_hqt
     f ,muf2
      include 'const.F'
      include '../Commons/common-order.f'
      include '../Commons/common-cplngs.f'
      include '../Commons/common-cuts.f'
      include '../Commons/common-scalesintvars.f'
      include '../Commons/common-pdfvals.f'
      include '../Commons/common-rescoeff.f'

      external fu,fd,adpint,alphs,S,abisq
      data gevpb/3.8937966d8/

c   Choose pp(ih2=1) or(ih2=-1) ppbar collider
      ih1 = 1
      ih2 = 1
      if(pp == 0) ih2 = -1
c  Choose CM energy
      sroot = dsqrt(Shad)
c  imod=0 original sudakov
c  imod=1 modified sudakov
      imod = 1
      amh = Hmass
! Change of the evolution scale
      resummscale = Qres
      a_param = amh/resummscale
      mur = muRen
      muf_hqt = muF
      mur2 = mur**2
      muf2 = muf_hqt**2
c......Parameters(amt=mtop, amh=mhiggs, gf=gfermi)
c................(nf=number of active flavours)
c................(flag=0,1 needs to call just once the pdfs fitting routine and evolution code initialization)
c................(flag1=1,2 set the order of resummation: NLL,NNLL)
c................(ippbar=1,-1 sets p-p or p-pbar events)
c................(iord sets the order for the evolution: LO(0),NLO(1))
c................(flag2 sets the order of matching: LO(1), NLO(2))
c................(nloop sets the order of the calculation)
c................(Flag channel: channel that contribuite to the cross-section 1=Tot, 2=GG, 3=GQ, 4=QQ)
c................(NEWA3: Flag for the new/old version of A3)

      call setHqTconstants()
com-- constants and flags that exist only in HqT:
      amt=172d0          ! mt pole mass for exact mass normalization
      xmb=4.67d0         ! mb pole mass for exact mass normalization
      arg1=(amt/amh)**2  ! used for exact mass normalization
      arg2=(xmb/amh)**2  ! used for exact mass normalization
!      ippbar=1          ! not used, instead ih2 used
      IF(resPDFset == 0) flag = 0 ! set to 0 first time to fit PDFs
      flagalphas=0       ! set to 0 otherwise LHAPDFs not reinitialized
                         ! by HqT => alphaS always NNLO
      NEWA3=.true.
      II=(0d0,1d0)
      ifail=0
      b0p=b0*a_param

      !gg_or_qq == 1 1(all)/2(gg)/3(gq)/4(qq)
      !gg_or_qq == 2 1(all)/2(bb-bar)/3(bg)/4(gg)/5(bb)/6(bq)/7(qq)
      channel = chan            
      flag1 = ord_in !logarithmic order NLL(1)/NNLL/(2)

      if (flag1.eq.1) then
         iord=0 ! LO evolution, needed also for resummed
!         flag2=1 ! LO matching, not needed
      elseif(flag1.eq.2) then
         iord=1 ! NLO evolution, needed also for resummed
!         flag2=2 ! NLO matching, not needed
      else
      write(*,*)'Wrong order (flag1) !'
      stop
      endif

! needed for native PDFs:
!      isetproton = 92 !MSTW2008 LO(90)/NLO(91)/NNLO(92) set
!      nset = 0 !PDFset
!      nloop = 3 ! nloop of alphaS in native PDFs LO(1)/NLO(2)/NNLO(3)
! needed for LHAPDF:
c$$$      IF(order == 1) THEN
c$$$         IF(ord_in == 1) THEN
c$$$            name = 'MSTW2008lo68cl.LHgrid'   !LHAPDF set
c$$$            pdforder = 1
c$$$         ENDIF
c$$$         IF(ord_in == 2) THEN
c$$$            name = 'MSTW2008nlo68cl.LHgrid'   !LHAPDF set
c$$$            pdforder = 2
c$$$         ENDIF
c$$$      ELSEIF(order == 2) THEN
c$$$         IF(ord_in == 1) THEN
c$$$            name = 'MSTW2008nlo68cl.LHgrid'   !LHAPDF set
c$$$            pdforder = 2
c$$$         ENDIF
c$$$         IF(ord_in == 2) THEN
c$$$            name = 'MSTW2008nnlo68cl.LHgrid'   !LHAPDF set
c$$$            pdforder = 3
c$$$         ENDIF         
c$$$      ELSE
c$$$         print*, 'wrong order'
c$$$         stop
c$$$      ENDIF

      IF(ord_in == 1) THEN
         name = prefixNLO !LHAPDF set
         pdforder = 2
      ELSEIF(ord_in == 2) THEN
         name = prefixNNLO !LHAPDF set
         pdforder = 3
      ELSE
         call printstop('wrong order in autohiggs')
         stop
      ENDIF

      mem = iset                             !LHAPDF member

         
! Initializzation for native PDFs, dummy for LHAPFD
      call lambda5qcd(xlam,isetproton)
! Initializzation for LHAPFD, dummy for native PDFs
      call inizializzazPDF()


c.....Sudakov coefficients defined 
c.....according to Catani-De Florian-Grazzini
c.....WARNING!!!
c.....they are defined according to alphas/pi normalization!!!
c.....Now I added B2-dependence from resummation scheme 
c.....both for Higgs prodution and DY process

c.....choice of resummation scheme
      flag4=1 ! H = 1 (1) 

c.....Choosing processes and scales
      shad_hqt=sroot**2
      q=amh
      q2=q**2
      xtau=q2/shad_hqt
      LT=2.0D0*dlog(q/amt)
      
c.....gluon coefficients
      A1g = CA
      A2g = CA/2d0 * (67/6d0-(pi**2)/2d0-5d0/9*nf)

c.....exact result for A3 for threshold resummation
      if(NEWA3)then
!Thomas Becher & Matthias Neubert arXiv: 1007.4005
!their normalization: aass/4/Pi, our normalization: aass/Pi ->  A3g = A3g/64d0 & Beta0=4d0*Beta0
      Gamma2g = 4d0*CA*(CA**2 *(245d0/6d0 - 134d0*pi**2/27d0
     . + 11d0*Pi**4 /45d0 + 22d0*Z3/3d0) + CA*TR*nf*(-418d0/27d0
     . + 40d0*Pi**2/27d0 - 56d0*Z3/3d0) + CF*TR*nf*(-55d0/3d0 + 16d0
     . * Z3) - 16d0/27d0 * TR**2 * nf**2)

      dg2 = CA*(CA*(808d0/27d0 - 28d0*Z3) - 224d0/27d0*TR*nf)

      A3g = Gamma2g + 2d0 *(4d0*Beta0) * dg2
      A3g = A3g/64d0
!      A3g= -14.544163962735272d0
      else
      A3g=CA*(13.7683d0-2.14673d0*nf-nf**2/108d0)
!      A3g= 8.4095055555555582d0
      endif

      B1g=-(11*CA-2*nf)/6d0
      if (flag4.eq.1) then
         B2g=CA**2*(23/24d0+(11*pi**2)/18d0-3*Z3/2d0)+
     /        Cf*nf/2d0-CA*nf*(1/12d0+pi**2/9d0)-11/8d0*Cf*CA 
         C1ggn=(pi**2/2d0+11/2d0+pi**2)/2d0
      elseif (flag4.eq.2) then
         B2g=(Cf*nf/2d0+2*CA*nf/3d0-CA**2*(8/3d0+3*Z3))/2d0
         C1ggn=-pi**2/2d0/2d0
      elseif (flag4.eq.3) then
         B2g=(Cf*nf/2d0+2*CA*nf/3d0-CA**2*(8/3d0+3*Z3))/2d0
     /        +pi**2/2d0*beta0
         C1ggn=0d0
      endif


c.....quark coefficients
      A1q=Cf
      A2q=Cf/2d0*(67/6d0-(pi**2)/2d0-5/9d0*nf)

      if(NEWA3)then

      Gamma2q = 4d0*CF*(CA**2 *(245d0/6d0 - 134d0*pi**2/27d0
     . + 11d0*Pi**4 /45d0 + 22d0*Z3/3d0) + CA*TR*nf*(-418d0/27d0
     . + 40d0*Pi**2/27d0 - 56d0*Z3/3d0) + CF*TR*nf*(-55d0/3d0 + 16d0
     . * Z3) - 16d0/27d0 * TR**2 * nf**2)

      dq2 = CF*(CA*(808d0/27d0 - 28d0*Z3) - 224d0/27d0*TR*nf)

      A3q = Gamma2q + 2d0 *(4d0*Beta0) * dq2
      A3q = A3q/64d0
!      A3q= -6.4640728723267875d0
      else
      A3q=Cf*(13.81-2.15*nf-nf**2/108d0)
!      A3q= 3.7713579483974127d0
      endif

      B1q=-(3*Cf)/2d0
      if (flag4.eq.1) then
! make shure to be right at NNLL !!!
! what is C1qqn in that case???
         B2q=Cf**2*(pi**2/4d0-3/16d0-3*Z3)+
     /        CA*Cf*(11*pi**2/36d0-193/48d0+3*Z3/2d0)+
     /        Cf*nf*(17/24d0-pi**2/18d0)
      elseif (flag4.eq.2) then
         B2q=1/2d0*Cf*nf*(1/6d0+2*pi**2/9d0)-
     /        CA*Cf*(17/24d0+11*pi**2/18d0-3*Z3)-
     /        Cf**2*(3/8d0-pi**2/2d0+6*Z3)
      elseif (flag4.eq.3) then
         B2q=Cf**2*(pi**2/4d0-3/16d0-3*Z3)+
     /        CA*Cf*(-11*pi**2/72d0-13/16d0+3*Z3/2d0)+
     /        Cf*nf*(1/8d0+pi**2/36d0)
      endif

      CALL init_gorq_rescoeff() !use gluon(1) or quark(2) coeff.

c.....here alphas gives alphas/4pi at the renormalization scale "mur".
c.....if you need alphas,    you have to write aass=alphas*4*pi
c.....if you need alphas/pi, you have to write aass=alphas*4
c     aass=alphs(cmplx(q2))*4*pi
      aass=dreal(alphs(dcmplx(mur2)))*4d0
      if(verbose.eq.2) then
      write(6,*)
      write(6,*)
      write(6,44) '   alpha_S(',sqrt(mur2),' GeV) = ',aass*pi
      write(12,44) '( alpha_S(',sqrt(mur2),' GeV) = ',aass*pi
      endif
  44  format(A,F7.2,A,F8.6)

c.....Here you choose NP smearing
      g = np_smearing

c.....Here you choose normalization: 0 -> mt=infinity, 1 -> mt exact
      inorm = 0

      factor=gf/288d0/pi/dsqrt(2d0)*AMPLO(amh**2)

c.....Please note here you need aass, not aass/pi or aass/4pi!!!!!!
      IF(gg_or_qq == 1) THEN
      sigma0 = factor*gevpb*(aass*pi)**2        !sigma0 for gluon fusion
      ELSEIF(gg_or_qq == 2) THEN
      sigma0 = pi/6d0*Hbb(order)/Hmass**2*gevpb !sigma0 for bb->H
      ELSE
         call printstop('Error in "get_resummed"'//
     f        ', gg_or_qq neither =1(gg) nor =2(qq).')
      ENDIF
c.....Here starts the integration: you can choose 
c.....the parameters v,phi,min,max
c.....To integrate on complex plane set phi=pi/8,max=10
c........and set the Sudakov without the b-cutoff
c.....To integrate on real axis set phi=0,max=1
c........and set the Sudakov with the b-cutoff
      flagrealcomplex=1 ! real(0)/complex(1) integration

      if (flagrealcomplex.eq.0) then
C     real axis
         v=1d0
         phi=0d0
         min=1d-5
         max=3d0
      if(verbose.eq.2) then
      write (6,45) '   Mh= ',amh, 'GeV, real axis'
      write (12,45) '( Mh= ',amh, 'GeV, real axis'
      endif
      else
c  complex plane
         v=1d0
         phi=pi/9
         min=1d-5
         max=10d0
         phi=pi/4
         min=1d-5
         max=3d0
      if(verbose.eq.2) then
      write (6,45) '   Mh= ',amh, 'GeV, complex plane'
      write (12,45) '( Mh= ',amh, 'GeV, complex plane'
      endif
      endif
  45  format(A,F7.2,A)
      close(11)


      if(verbose.eq.2) then
      write (6,45) '   Q=  ',resummscale, 'GeV'
      write (12,45) '( Q=  ',resummscale, 'GeV'
      write (6,46) '   mur=',mur, 'GeV, muf=',muf_hqt,'GeV'
      write (12,46) '( mur=',mur, 'GeV, muf=',muf_hqt,'GeV'
      write (6,47) '   g=',g, ', norm=',inorm
      write (12,47) '( g=',g, ', norm=',inorm
      write(*,*)'Wait for pdf fit...'
      endif
  46  format(A,F7.2,A,F7.2,A)
  47  format(A,F5.2,A,I3)

c.....this is one-time calculation of luminosities for LL result
      if (flag1.eq.0) then
         call evolfast (dcmplx(muf2),qqb1,qg1,gg1)
         LLgg=gg1
      endif

!      qtmin = pT_Hmin !verwende loop auerhalb dieser routine!
!      qtmax = pT_Hmax
!      qtbin = stepsize
         qt = pTH !set transverse momentum
         qt2=qt**2

c.....Initializing values and jacobian
         tmp1=0d0
         tmp2=0d0
         jac=cos(phi)+II*sin(phi)         
c....."upper-real" integral
         j=1
         tmp1=adpint(fu,min,max,1d-10,1d-5,errest,ifail)    
c....."upper-complex" integral
         j=2
!         tmp2=adpint(fu,min,max,1d-10,1d-5,errest,ifail) !complex part
         ru=tmp1+II*tmp2
c.....Reinitializing values and jacobian
         tmp1=0d0
         tmp2=0d0
         jac=cos(phi)-II*sin(phi)         
c....."lower-real" integral
         j=1
         tmp1=adpint(fd,min,max,1d-10,1d-5,errest,ifail)
c....."lower-complex" integral
         j=2
!         tmp2=adpint(fd,min,max,1d-10,1d-5,errest,ifail) !complex part
         rd=tmp1+II*tmp2
c.....Putting upper amd lower integrals together
c.....Now this is (d_sigma^Res/d_qt) with sigma(LO) normalization
         rr       = (ru+rd)
         allres   = 2*xtau*qt*sigma0*dreal(rr)/4d0
         resummed = allres
         
         muF = muf_hqt
         IF(flag == 1) resPDFset = 1
      end
      
c.....Function to be integrated in the upper complex b plane
      function fu(t)
      implicit none
      integer j,flag1,iord,nloop
      real *8 t,fu
      complex *16 qqb,qg,gg,LLgg
      complex *16 tmp,b,jac,h1,S
      complex *16 final
      common/order_hqt/iord
      common/nloop/nloop
      common/jac/jac
      common/j/j
      common/flag1/flag1
      common/LLgg/LLgg

      real *8 a_param,b0p
      common/a_param/a_param,b0p

      external h1,S
      include 'scales.F'
      include 'const.F'
      if (flag1.eq.0) then
         b=jac*t
         tmp=jac*b*h1(qt*b)*S(b)*LLgg
         if(j.eq.1) then
            fu=dreal(tmp)
         elseif(j.eq.2) then
            fu=dimag(tmp)
         endif
      else
         b=jac*t
c         final=(b0p**2)/(b**2)      ! Change of the evolution scale
         final=(b0**2)/(b**2)
         call evolfast(final,qqb,qg,gg) !ndern
         tmp=jac*b*h1(qt*b)*S(b)*gg
         if(j.eq.1) then
            fu=dreal(tmp)
         elseif(j.eq.2) then
            fu=dimag(tmp)
         endif
      endif
      return
      end
      
c.....Function to be integrated in the lower complex b plane
      function fd(t)
      implicit none
      integer j,flag1,iord,nloop
      real *8 t,fd
      complex *16 qqb,qg,gg,LLgg
      complex *16 tmp,b,jac,h2,S
      complex *16 final
      common/order_hqt/iord
      common/nloop/nloop
      common/jac/jac
      common/j/j
      common/flag1/flag1
      common/LLgg/LLgg

      real *8 a_param,b0p
      common/a_param/a_param,b0p

      external h2,S
      include 'scales.F'
      include 'const.F'
      if (flag1.eq.0) then
         b=jac*t
         tmp=jac*b*h2(qt*b)*S(b)*LLgg
         if(j.eq.1) then
            fd=dreal(tmp)
         elseif(j.eq.2) then
            fd=dimag(tmp)
         endif
      else
         b=jac*t
c         final=(b0p**2)/(b**2)      ! Change of the evolution scale
         final=(b0**2)/(b**2)
         call evolfast(final,qqb,qg,gg) !ndern
         tmp=jac*b*h2(qt*b)*S(b)*gg
         if(j.eq.1) then
            fd=dreal(tmp)
         elseif(j.eq.2) then
            fd=dimag(tmp)
         endif
      endif
      return
      end

c.....Sudakov form factor
      function S(b)
      implicit none
      integer flag1,flagrealcomplex,imod
      complex *16 S,f0,f1,f2,b,bstar,blim,blog
      real*8 a_param,b0p,aass,g
      common/aass/aass
      common/flag1/flag1
      common/flagrealcomplex/flagrealcomplex
      common/modified/imod
      common/a_param/a_param,b0p
      common/NP/g
      include 'scales.F'
      include 'const.F'
      blim=(1/q)*exp(1/(2*aass*beta0))

      bstar=b
c.....choose bstar (b) for real axis (complex plane) integration
CC      if (flagrealcomplex.eq.0) bstar=b/sqrt(1+(b**2)/(blim**2))

      if (imod.eq.1) blog=log( (q*bstar/b0p)**2+1d0)    !modified sudakov
      if (imod.eq.0) blog= log( (q*bstar/b0p)**2 )    !normal sudakov

      if (flag1.eq.0) then
         S=exp(blog*f0(beta0*aass*blog))

      elseif (flag1.eq.1) then
         S=exp(blog*f0(beta0*aass*blog) +
     /                           f1(beta0*aass*blog))

      elseif (flag1.eq.2) then
         S=exp(blog*f0(beta0*aass*blog) +
     /                           f1(beta0*aass*blog) +
     /                        aass*f2(beta0*aass*blog))

      endif
      S=S*exp(-g*b**2)

      return
      end
      
      
c.....Soft-gluon-Resummation of LL
      function f0(y)
      implicit none
      complex *16 f0,y
      include 'const.F'
      include 'scales.F'
      include '../Commons/common-rescoeff.f'
      f0=(A1/beta0)*(y+log(1-y))/(y)
      return
      end
      
c.....Soft-gluon-Resummation of NLL
c.....Now we have mu_r dependence!
      function f1(y)
      implicit none
      complex *16 f1,y
      include 'const.F'
      include 'scales.F'
      real *8 a_param,b0p
      common/a_param/a_param,b0p
      include '../Commons/common-rescoeff.f'

      f1=((A1*beta1)/(beta0**3))*((1d0/2)*log(1-y)*log(1-y) +
     \     (y)/(1-y)+log(1-y)/(1-y)) -
     \     (A2/(beta0**2))*(log(1-y)+(y)/(1-y)) + 
     \     (B1/beta0)*log(1-y) +
     \     (A1/beta0)*(y/(1-y)+log(1-y))*log(q2/mur2)


c    a dependence
      
      f1=f1-2*log(a_param)*A1/beta0*y/(1-y)
      return
      end

c.....Soft-gluon-Resummation of NNLL
c.....Now we have mu_r dependence!
      function f2(y)
      implicit none
      complex *16 f2,y
      include 'const.F'
      include 'scales.F'
      real *8 a_param,b0p
      common/a_param/a_param,b0p
      include '../Commons/common-rescoeff.f'

c      C1=(pi**2/2d0+11/2d0+pi**2)/2d0

      f2=((A2*beta1)/(beta0**3))*((y/2)*((3*y-2d0)/(1-y)**2)-
     \     ((1-2*y)*log(1-y)/(1-y)/(1-y))) - 
     \     (B2/beta0)*((y)/(1-y))+
     \     (B1*beta1/beta0**2)*((y)/(1-y)+log(1-y)/(1-y))-
     \     (A3/2/beta0**2)*(y)*(y)/(1-y)/(1-y) +
     \     A1*((beta1**2/2/beta0**4)*(1-2*y)/(1-y)
     \     /(1-y)*log(1-y)*log(1-y) +
     \     log(1-y)*((beta0*beta2-beta1**2)/(beta0**4)+
     \     beta1**2/beta0**4/(1-y)) +
     \     (y)/(2*beta0**4*(1-y)*(1-y))*
     \     (beta0*beta2*(2d0-3*y)+beta1**2*y)) -
     \     (A1/2)*(y)*(y)/(1-y)/(1-y)*log(q2/mur2)*log(q2/mur2) +
     \     log(q2/mur2)*(B1*y/(1-y)+A2/beta0*y*y/(1-y)/(1-y)+
     \     A1*beta1/beta0**2*(y/(1-y)+(1-2*y)/(1-y)/(1-y)*log(1-y))) 
     \     +2d0*C1ggn*((y)/(1-y)) ! nder fr NNLL


c    a dependence (now without constant term)

c     f2=f2-2*A1g/(1-y)**2*(log(a_param))**2-log(a_param)/(1-y)**2
c    \    *(2*B1g*(1-y)+2*y/beta0*A2g-2*A1g*beta1/beta0**2*y*log(1-y))


      f2=f2+2*A1*y*(y-2)/(1-y)**2*log(a_param)**2-log(a_param)
     \ *(2*B1*y/(1-y)+2*y/beta0*A2g/(1-y)**2
     \ -2*A1*beta1/beta0**2*y*log(1-y)/(1-y)**2)
     \ +2d0*A1*y*log(q2/mur2)*log(a_param)/(1-y)**2    !Double log-dependent term
      return
      end
      

      SUBROUTINE setHqTconstants()
      implicit none
      integer nf_hqt
      DOUBLE PRECISION gf_hqt
      common/nf/nf_hqt
      common/gf/gf_hqt
      real* 8 Euler,Z2,Z3
      real *8 beta0_hqt,beta1_hqt,beta2_hqt,A1g,A2g,A3g,B1g,B2g,
     &     A1q,A2q,A3q,B1q,B2q,CA_hqt,Cf_hqt,TR_hqt,b0_hqt,C1ggn
      real *8 pi
      complex *16 II
      common/Euler/Euler
      common/Zeta/Z2,Z3
      common/const/beta0_hqt,beta1_hqt,beta2_hqt,A1g,A2g,A3g,B1g,B2g,
     &     A1q,A2q,A3q,B1q,B2q,CA_hqt,Cf_hqt,TR_hqt,b0_hqt,C1ggn
      common/data/pi,II
      include '../Commons/common-constants.f'
      nf_hqt = nf
      gf_hqt = gF
      CA_hqt = cA
      Cf_hqt = cF
      TR_hqt = tR
      pi     = Pii
      Z2 = zeta2
      Z3 = zeta3
c..............(beta_i=beta function coefficients defined to aass/pi)
      beta0_hqt = beta0 / 2d0 ! beta0 in main prog def to aS/2pi !
      beta1_hqt = (153-19*nf)/24d0
      beta2_hqt = 2857/128d0-5033*nf/1152d0+325*nf**2/3456d0
c..............(Euler=Euler's Gamma function)
      Euler  = 0.57721566d0
      b0_hqt = b0
      END

      SUBROUTINE init_gorq_rescoeff()
      implicit none
      include '../Commons/common-rescoeff.f'
      include 'const.F'

      IF(gg_or_qq == 1) THEN
      A1 = A1g
      A2 = A2g
      A3 = A3g
      B1 = B1g
      B2 = B2g
      C1 = C1ggn
      ELSEIF(gg_or_qq == 2) THEN
      A1 = A1q
      A2 = A2q
      A3 = A3q
      B1 = B1q
      B2 = B2q
      C1 = 0d0
      ELSE
         call printstop('Error in "init_gorq_rescoeff"'//
     f        ', gg_or_qq neither =1(gg) nor =2(qq).')
      ENDIF
!      A1=2d0*cF
!      A2=2d0*cF*((67d0/18d0-Pii**2/6d0)*cA-50d0/9d0*tR)
!      B1=-3d0*cF
!      B2=1d0
      END
