com-- These Routines were taken from HqT and modified for our purposes.
com-- G. Bozzi, S. Catani, D. de Florian, M. Grazzini
com-- Phys. Lett. B564 (2003) 65 [hep-ph/0302104]
com-- Nucl. Phys. B737 (2006) 73 [hep-ph/0508068]    

*****************
* LHAPDF version*
*****************

      subroutine lambda5qcd(lam,iset)
! Initializzation for native PDFs, dummy for LHAPFD
      implicit none
      integer iset
      real*8 lam
      end


      subroutine inizializzazPDF()
      integer flagalphas,mem,Nmem,pdforder,verbose
      character name*64
      double precision alphasPDF,QMZ
      complex*16 alphs
      common/flagalphas/flagalphas
      common/PDFname/name,pdforder
      common/mem/mem
      COMMON /verbose/ verbose

      if(flagalphas.eq.0) then
!      write (6,*)
      if(verbose.eq.2) then
      write (6,*)'****************************************************'
      write (6,*)'*                                                  *'
      write (6,*)'*       MoRe-SusHi runs with LHAPDF routines       *'
      write (6,*)'*                                                  *'
      write (6,*)'****************************************************'
!      write (6,*)
      write (6,48) '   ',name,', mem=',mem
      endif
  48  format(A,A25,A,I3)
!        call InitPDFsetByNamem(1,name)
!        call numberPDF(1,Nmem)
!        if(mem.gt.Nmem) then
!          write(*,*)'input mem out of range!!!'
!          stop
!        endif
!        call InitPDF(1,mem)
!        call initPDFs
        flagalphas=1
      endif

      end


      function alphs(nq2)
c.....N.B.:Here you have in output alpha_s/(4*Pi)!!!!!
      implicit none
      double precision alphasPDFm,xmu,pi,alpha_s
      complex*16 alphs,nq2
      real*8 f(-6:6)
      data pi/3.14159265358979323846264338d0/
      integer pdforder
      character name*64
      common/PDFname/name,pdforder

      xmu=dreal(cdsqrt(nq2))
!      alphs=DCMPLX(alphasPDFm(pdforder,xmu),0d0)
      alphs=DCMPLX(alpha_s(pdforder-1),0d0)
      alphs=alphs/4d0/Pi
      return
      end


      SUBROUTINE partons(xmu,X,FX,NF,ISET,IH)
! Unused variables NF,ISET
      implicit none
      integer Iprtn,ih,Irt,NF,ISET
      double precision fx(-NF:NF),x,xmu,sqrtxmu,fPDF(-6:6),temp
      integer pdforder
      character name*64
      common/PDFname/name,pdforder
!      double precision UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU
c---  ih1=+1 proton
c---  ih1=-1 pbar

C---set to zero if x out of range
      if (x .ge. 1d0) then
          do Iprtn=-5,5
             fx(Iprtn)=0d0
          enddo
          return
      endif
      sqrtxmu=sqrt(xmu)
      call evolvePDFm(pdforder,x,sqrtxmu,fPDF)
      if (ih.eq.1) then
        do Iprtn=-5,5
          fx(Iprtn)=fPDF(Iprtn)/x
        enddo
      elseif(ih.eq.-1) then
        do Iprtn=-5,5
          fx(+Iprtn)=fPDF(-Iprtn)/x
        enddo
      endif

! With our convention the quarks u and d are exchanged
      temp=fx(1)
      fx(1)=fx(2)
      fx(2)=temp
      temp=fx(-1)
      fx(-1)=fx(-2)
      fx(-2)=temp

      return
      end
