com-- 
com-- calls all initialization routines
com-- 
C-{{{ SUBROUTINE: initial

      SUBROUTINE initial()
      implicit none
      include 'Commons/common-scalesintvars.f'

      CALL setConstants()
      CALL defaultParameters()
c      CALL printVersion()
      CALL printcopymoresushi(1,6,1)
c      CALL initial_real()
      CALL initParameters()
      CALL runCouplings(muRen,muRenFO)
      CALL outputmoresushi()
      END

C-}}}

com-- 
com-- prints program name and version
com-- 
C-{{{ SUBROUTINE: printVersion

c$$$      SUBROUTINE printVersion()
c$$$      include 'Commons/common-output.f'
c$$$
c$$$
c$$$      write(*,1) "#--------------------------------------------------#"
c$$$      write(*,1) "#    SusHi-pT:    Transveral momentum distribution #"
c$$$      write(*,1) "#  __      __          _        of the Higgs Boson #"
c$$$      write(*,1) "# [_  | | [_  |_| | _ |_]                          #"
c$$$      write(*,1) "# __] |_| __] | | |   |  ___    Version "//version
c$$$     &//' #'
c$$$      write(*,1) "#                         |              "//date
c$$$     &// '  #'
c$$$c      if (fullflag.eq.1) then
c$$$      write(*,1) "#                                                  #"
c$$$      write(*,1) "#                     H. Mantler and M. Wiesemann  #"
c$$$      write(*,1) "#                              (hmantler@cern.ch)  #"
c$$$      write(*,1) "#                        (dr.wiesemann@gmail.com)  #"
c$$$      write(*,1) "#--------------------------------------------------#"
c$$$      write(*,1) "# SusHi-pT is based on a number of calculations    #"
c$$$      write(*,1) "# due to various groups. Please acknowledge these  #"
c$$$      write(*,1) "# efforts by citing the list of references which   #"
c$$$      write(*,1) "# are included in the output file of every run.    #"
c$$$c       end if
c$$$      write(*,1) "#--------------------------------------------------#"
c$$$
c$$$      write(*,1)
c$$$     &"#--------------------------------------------------------------#"
c$$$      write(*,1)
c$$$     &"#       MoRe-SusHi:          Transverse momentum distribution  #"
c$$$      write(*,1)
c$$$     &"#  _  _   __   _   _      __      __       of the Higgs Boson  #"
c$$$      write(*,1)
c$$$     &"# | \/ | |  | |_| |_  _  [_  | | [_  |_| |                     #"
c$$$      write(*,1)
c$$$     &"# |    | |__| | \ |_     __] |_| __] | | |       Version "
c$$$     &//version//' #'
c$$$      write(*,1)
c$$$     &"#                                                     "
c$$$     &//date// ' #'
c$$$c      if (fullflag.eq.1) then
c$$$      write(*,1)
c$$$     &"#                                                              #"
c$$$      write(*,1)
c$$$     &"#                                 H. Mantler and M. Wiesemann  #"
c$$$      write(*,1)
c$$$     &"#                                          (hmantler@cern.ch)  #"
c$$$      write(*,1)
c$$$     &"#                                    (dr.wiesemann@gmail.com)  #"
c$$$      write(*,1)
c$$$     &"#--------------------------------------------------------------#"
c$$$      write(*,1)
c$$$     &"# MoRe-SusHi is based on a number of calculations due to       #"
c$$$      write(*,1)
c$$$     &"# various groups. Please acknowledge these efforts by citing   #"
c$$$      write(*,1)
c$$$     &"# the list of references which are included in the output file #"
c$$$      write(*,1)
c$$$     &"# of every run.                                                #"
c$$$c       end if
c$$$      write(*,1)
c$$$     &"#--------------------------------------------------------------#"
c$$$
c$$$
c$$$
c$$$
c$$$      write(*,1)
c$$$      write(*,1)
c$$$     &"#-----------------------------------------------------#"
c$$$      write(*,1)
c$$$     &"# Transverse momentum distribution of the Higgs Boson #"
c$$$      write(*,1)
c$$$     &"#       _  _   __   _   _      __      __             #"
c$$$      write(*,1)
c$$$     &"#      | \/ | |  | |_| |_  _  [_  | | [_  |_| |       #"
c$$$      write(*,1)
c$$$     &"#      |    | |__| | \ |_     __] |_| __] | | |       #"
c$$$      write(*,1)
c$$$     &"#                                                     #"
c$$$      write(*,1)
c$$$     &"# Version "//version//"   "//date
c$$$     &//"   (dr.wiesemann@gmail.com) #"
c$$$c      if (fullflag.eq.1) then
c$$$      write(*,1)
c$$$     &"# H. Mantler and M. Wiesemann      (hmantler@cern.ch) #"
c$$$c$$$      write(*,1)
c$$$c$$$     &"#                                                     #"
c$$$c$$$      write(*,1)
c$$$c$$$     &"#                                                     #"
c$$$      write(*,1)
c$$$     &"#-----------------------------------------------------#"
c$$$      write(*,1)
c$$$     &"# MoRe-SusHi is based on a number of calculations due #"
c$$$      write(*,1)
c$$$     &"# to various groups. Please acknowledge these efforts #"
c$$$      write(*,1)
c$$$     &"# by citing the list of references which are included #"
c$$$      write(*,1)
c$$$     &"# in the output file of every run.                    #"
c$$$c       end if
c$$$      write(*,1)
c$$$     &"#-----------------------------------------------------#"
c$$$
c$$$ 1    format(a)
c$$$
c$$$      END

C-}}}

com-- 
com-- sets constants used in calculation
com-- 
C-{{{ SUBROUTINE: setConstants

      SUBROUTINE setConstants()
      implicit none
      include 'Commons/common-constants.f'
      GeVpb = 0.38937966d9
      cA    = 3d0
      cF    = 4d0/3d0
      nf    = 5d0
      tR    = 1d0/2d0
      beta0 = (33d0-2d0*nf)/6d0
      zeta2 = Pii**2/6d0
      zeta3 = 1.2020569031595942853997d0
      zeta4 = Pii**4/90d0
      b0    = 1.12291896713377d0
      vev=246.220569d0
      END

C-}}}

com-- 
com-- initialize PDF sets and determines alpha_s(mZ) 
com-- 
C-{{{ SUBROUTINE: initPDFs

      SUBROUTINE initPDFs()
      implicit none
      DOUBLE PRECISION alphaspdfm
      include 'Commons/common-constants.f'
      include 'Commons/common-cplngs.f'
      include 'Commons/common-pdfvals.f'

      CALL SetLHAPARM('LOWKEY')
      CALL SetLHAPARM('SILENT')

      CALL initpdfsetbynamem(1,prefixLO)
      CALL initpdfm(1,iset)
      alphamZLO = alphaspdfm(1,mZ)
      CALL initpdfsetbynamem(2,prefixNLO)
      CALL initpdfm(2,iset)
      alphamZNLO = alphaspdfm(2,mZ)
      CALL initpdfsetbynamem(3,prefixNNLO)
      CALL initpdfm(3,iset)
      alphamZNNLO = alphaspdfm(3,mZ)
      END

C-}}}

com-- 
com-- runs Couplings and fills common-block /Couplings/ 
com-- 
C-{{{ SUBROUTINE: runCouplings

      SUBROUTINE runCouplings(muR,muRFO)
      implicit none
      DOUBLE PRECISION muR,muRFO,alphamb,alphamZ,mbmuR,alphaspdfm
      include 'Commons/common-constants.f'
      include 'Commons/common-cplngs.f'

      call runalpha(alphamZLO/Pii,mZ,muR,nf,1,0,alphaLO)
      call runalpha(alphamZNLO/Pii,mZ,muR,nf,2,0,alphaNLO)
      call runalpha(alphamZNNLO/Pii,mZ,muR,nf,3,0,alphaNNLO)
      alphaLO   = alphaLO*Pii
      alphaNLO  = alphaNLO*Pii
      alphaNNLO = alphaNNLO*Pii

      call runalpha(alphamZLO/Pii,mZ,muRFO,nf,1,0,alphaLOFO)
      call runalpha(alphamZNLO/Pii,mZ,muRFO,nf,2,0,alphaNLOFO)
      call runalpha(alphamZNNLO/Pii,mZ,muRFO,nf,3,0,alphaNNLOFO)
      alphaLOFO   = alphaLOFO*Pii
      alphaNLOFO  = alphaNLOFO*Pii
      alphaNNLOFO = alphaNNLOFO*Pii

      call runalpha(alphamZLO/Pii,mZ,mbmb,nf,1,0,alphamb)
      call runmass(mbmb,alphamb,alphaLO/Pii,nf,1,mbmuR)
      HbbLO= mbmuR**2/ 246.220569d0**2
      mbmuR=0d0

      call runalpha(alphamZNLO/Pii,mZ,mbmb,nf,2,0,alphamb)
      call runmass(mbmb,alphamb,alphaNLO/Pii,nf,2,mbmuR)
      HbbNLO= mbmuR**2/ 246.220569d0**2
      mbmuR=0d0

      call runalpha(alphamZNNLO/Pii,mZ,mbmb,nf,3,0,alphamb)
      call runmass(mbmb,alphamb,alphaNNLO/Pii,nf,3,mbmuR)
      HbbNNLO= mbmuR**2/ 246.220569d0**2

c$$$      print*, 'a(mZ)',alphamZLO,alphamZNLO,alphamZNNLO
c$$$      print*, 'alpha',alphaLO,alphaNLO,alphaNNLO
c$$$      print*, 'Hbb  ',HbbLO,HbbNLO,HbbNNLO
c$$$      print*, 'mb   ',dsqrt(HbbLO)*246.220569d0
c$$$     f ,dsqrt(HbbNLO)*246.220569d0,dsqrt(HbbNNLO)*246.220569d0
      END

C-}}}

com-- 
com-- functions to get couplings in calculation
com-- 
C-{{{ FUNCTION: alpha_s

      DOUBLE PRECISION FUNCTION alpha_s(order)
      implicit none
      include 'Commons/common-cplngs.f'
      INTEGER order
      alpha_s=0d0
      IF(order==0) alpha_s=alphaLO
      IF(order==1) alpha_s=alphaNLO
      IF(order==2) alpha_s=alphaNNLO
      IF(alpha_s==0d0) THEN
      print*, 'ACHTUNG keine Ordnung gesetzt -- Programm gestoppt !!!'
      stop
      ENDIF
      END

C-}}}
C-{{{ FUNCTION: alpha_sFO

      DOUBLE PRECISION FUNCTION alpha_sFO(order)
      implicit none
      include 'Commons/common-cplngs.f'
      INTEGER order
      alpha_sFO=0d0
      IF(order==0) alpha_sFO=alphaLOFO
      IF(order==1) alpha_sFO=alphaNLOFO
      IF(order==2) alpha_sFO=alphaNNLOFO
      IF(alpha_sFO==0d0) THEN
      print*, 'ACHTUNG keine Ordnung gesetzt -- Programm gestoppt !!!'
      stop
      ENDIF
      END

C-}}}
C-{{{ FUNCTION: Hbb

      DOUBLE PRECISION FUNCTION Hbb(order)
      implicit none
      include 'Commons/common-cplngs.f'
      INTEGER order
      Hbb=0d0
      IF(order==0) Hbb=HbbLO
      IF(order==1) Hbb=HbbNLO
      IF(order==2) Hbb=HbbNNLO
      IF(Hbb==0d0) THEN
      print*, 'ACHTUNG keine Ordnung oder Kopplung gesetzt',
     f'-- Programm gestoppt !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      stop
      ENDIF
      END

C-}}}

com-- 
com-- Subroutine to set default values for local parameters. Some
com-- parameters don't get default. Program will terminate if they
com-- are not set in slha-Input-File
com-- 
C-{{{ SUBROUTINE: defaultParameters

      SUBROUTINE defaultParameters()
      implicit none
      DOUBLE PRECISION theta_W
      INTEGER i,j
      include 'Commons/common-output.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cplngs.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-chankeys.f'
      include 'Commons/common-results.f'
      include 'Commons/common-rescoeff.f'

com-- fill /results/ common-block with 0's
      DO i=0,2
         DO j=0,1
            sigma(i,j)=0d0
            jet0(i,j) =0d0
            tot(i,j)  =0d0
         ENDDO
      ENDDO

      version= '   1.1.0   '
      date= '  Aug 2016'
      verbosept=1

      N=10000 !  Number of integrations -- N= 1000 : high error, 10000 : sufficient error for cross sections, 100000 : for K-factors of distributions
      order=1 !  1   --   NLO+NLL
              !  2   --   NNLO+NNLL

      pTH = 0d0  ! Get dSigma/dpT(pTH)
                 ! pTH<=0d0 =>bins from pT_Hmin to pT_Hmax with stepsize
      pT_Hmin = 0d0
      pT_Hmax = 0d0

      prefixLO  = "MMHT2014lo68cl.LHgrid"
      prefixNLO = "PDF4LHC15_nlo_100.LHgrid"
      prefixNNLO= "PDF4LHC15_nnlo_100.LHgrid"
      pp=1
      iset=0 !PDFset 0 -- central value; goes from 0 to 40
c$$$      eoa=0  ! e(rror) o(f) a(lpha)  :::  eoa = 0  --  central value; goes from 0 to 4
c$$$      clOfErr=68 ! confidence level of Error  :::  choose 68 or 90      
c      dataName='Plots/File_data'
c      dataLog='Plots/File_log'

com-- keys to switch on and turn of subchannels -{
      ggkey   = 1
      gqkey   = 1
      qqkey  = 1
      totLOkey  = 1
      totNLOkey = 1
      totNNLOkey= 1      
      allAtOnce = 1 ! do integration of all channels simultaneously
      htlkey = 0
c$$$      toploopkey = 1
c$$$      botloopkey = 1
com-- }- keys

com-- SMinputs -{
      alpha=1d0/137.0359895d0
      gF=1.16637*10d0**(-5)
      mZ=91.1876d0
!      theta_W = 1d0/2d0 * dasin(2d0*sqrt(Pii*alpha/(gF*dsqrt(2d0)))/mZ)
      mW=80.399d0
      mbmb = 4.2d0
      mb = 4.75d0
      mT = 172d0
com-- }- SMinputs

com-- other (no input values) -{
      np_smearing = 0d0 !non-perturbative smearing
      resPDFset = 0     ! PDF fit in resummation not done yet
com-- }- other
      END

C-}}}

com-- 
com-- Subroutine to set local parameters to readed slha parameters.
com-- 
C-{{{ SUBROUTINE: initParameters

      SUBROUTINE initParameters()
      implicit none
      CHARACTER itmp*2,itmp2*2,tmp*11,chan*3,getalgorithm*11
      character infile*100,bltype*15
      integer dum_model,pseudo,out_len,strlen,blockflag
      double precision dum_GF,dum_mt,dum_mb,dum_mc,glgl_elw,elw_sushi
      double precision muRenfac
      logical ifilein
      include 'Commons/common-slha.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cplngs.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-chankeys.f'
      include 'Commons/common-output.f'
      common /ew/ elw_sushi

      CALL getarg(2,outfile)
      IF(outfile == '') THEN
         outfile = "out.moresushi"
      ENDIF
      out_len=strlen(outfile)
      paramfile  = outfile(1:out_len)//'_param'
      outfile_gg = outfile(1:out_len)//'_gg'
      outfile_gq = outfile(1:out_len)//'_gq'
      outfile_qq = outfile(1:out_len)//'_qq'

      CALL initrescoeff()

      CALL getarg(1,infile)

      inquire(file=infile,exist=ifilein)
      if(.not.ifilein)then
         write(6,*) 'MoRe-SusHi (error): ','ERROR: FILE '//infile
     &        //' DOES NOT EXIST!'
      endif

      open(unit=12,file=infile)

      CALL slharead_pt(12)

      bltype = 'FEYNHIGGS'
      call readslha(12,bltype,blockflag)
      if(blockflag.eq.1) then
         fhkey = .true.
      else
         fhkey = .false.
      endif

      bltype = '2HDMC'
      call readslha(12,bltype,blockflag)
      if(blockflag.eq.1) then
         thkey  = .true.
      else
         thkey  = .false.
      end if

      close(12)

com-- Block: MoReSusHi
      IF(MoReSusHi_SET( 1)) N = MoReSusHi_var( 1)
c      Shad = MoReSusHi_var(2)**2

      Shad = SusHi_var(4)**2

      IF(SMinput_SET(4)) mZ    = SMinput(4)

      IF(MoReSusHi_key_SET(11)) then
         htlkey    = MoReSusHi_key(11)
c      ELSE
c         If(htlkey == 1) chan = 'on'
c         If(htlkey == 0) chan = 'off'
c         CALL printinfo('Block MoReSusHikeys entry 11 missing.'// 
c     f   ' --> Using default: heavy-top approximation= "'//chan//'".')
      ENDIF

      if(SusHi_SET(19)) verbosept=SusHi_var(19)

      IF(Scales_SET(1)) THEN
         muRenfac = Scales_var(1)
      ELSE
         muRenfac = 1d0
      ENDIF
      if(verbosept.eq.1) write(*,*)
      if(verbosept.eq.1) write(*,*) "MoRe-SusHi is linked to"
      CALL SusHicall(infile,muRenfac,htlkey,dum_model,dum_GF,
     &dum_mt,dum_mb,mb,dum_mc,Hmass,pseudo,ewkey)

c$$$      if(verbosept.ne.0) then
c$$$      write(*,*) '******     m_H   =',Hmass,'******'
c$$$      write(*,*) '******  m_b^pole =',mb,'******'
c$$$      endif
      

c$$$      IF(MoReSusHi_SET( 3)) THEN
c$$$         Hmass = MoReSusHi_var( 3)
c$$$      ELSEIF(massBo_SET(25)) THEN
c$$$         Hmass = massBo(25)
c$$$         write(tmp,'(EN10.2)') Hmass
c$$$         CALL printinfo('Block ggHplusJET entry 3 missing. '//
c$$$     f   'Using Block SMINPUTS entry 25: m_H='//tmp)
c$$$      ELSE
c$$$         CALL printstop('Block ggHplusJET entry 3 and Block SMINPUTS'// 
c$$$     f   ' entry 25 missing. --> m_H not set.')
c$$$      ENDIF



com-- set Shad,Hmass dependend default parameters -{
      pT_Hmax =  dsqrt(Shad)/2d0*(1-Hmass**2/Shad)
      y_Hmin  = -dlog(dsqrt(Shad)/Hmass)
      y_Hmax  =  dlog(dsqrt(Shad)/Hmass)
      muF     = Hmass
      muRen   = Hmass
      muFFO   = Hmass
      muRenFO = Hmass
      runscale= 1
      Qres    = Hmass
com-- }-

      IF(Scales_SET( 2)) THEN
         muF       = Scales_var( 2) * Hmass
         muFFO     = Scales_var( 2) * Hmass
      ENDIF
      IF(Scales_SET( 1)) THEN
         muRen     = Scales_var( 1) * Hmass
         muRenFO   = Scales_var( 1) * Hmass
      ENDIF
      IF(Scales_SET(3)) runscale = Scales_var(3)
c      IF(MoReSusHi_SET(14)) Qres      = MoReSusHi_var(14) * Hmass
      IF(Scales_SET(4)) Qres     = Scales_var(4)
      IF(Scales_SET(5)) Qres     = Scales_var(5) * Hmass
!      IF(MoReSusHi_SET( 6)) order  = MoReSusHi_int( 6) 
      IF(PDF_SET(1)) prefixLO    = PDF_str(1) 
      IF(PDF_SET(2)) prefixNLO   = PDF_str(2) 
      IF(PDF_SET(3)) prefixNNLO  = PDF_str(3) 

c      IF(MoReSusHi_SET(19)) pp        = MoReSusHi_int(19)
      IF(SusHi_SET(3)) pp        = 1-int(SusHi_var(3))
      if(pp.eq.0) then
         CALL printstop('Proton-Antiproton collider is not supported.')
      endif
c     IF(PDF_SET(11)) iset       = PDF_int(11)
      IF(PDF_SET(12)) iset       = PDF_int(12)
c     IF(PDF_SET(13)) iset       = PDF_int(13)
      IF(PDF_SET(10))  iset       = PDF_int(10)
      IF(PDF_SET(10).and.PDF_SET(12)) THEN
         CALL printinfo('Block PDFSPEC entry 12 will be ignored.'// 
     f   ' --> Using entry 10 instead.')
      ENDIF

c      IF(MoReSusHi_SET(11)) dataName  = MoReSusHi_str(11)
c      IF(MoReSusHi_SET(12)) dataLog   = MoReSusHi_str(12)
      
com-- Block: DISTRIB2
      IF(distrib2_SET( 1)) pT_Hmin   = distrib2( 1)
      IF(distrib2_SET( 2)) pT_Hmax   = distrib2( 2)
      IF(distrib2_SET( 3))  y_Hmin   = distrib2( 3)
      IF(distrib2_SET( 4))  y_Hmax   = distrib2( 4)
      IF(distrib2_SET( 5))  stepsize = distrib2( 5)
      IF(distrib2_SET( 6))  pTH      = distrib2( 6)

com-- Block: MoReSusHikeys
      IF(MoReSusHi_key_SET(1)) ggkey      = MoReSusHi_key(1)
      IF(MoReSusHi_key_SET(2)) gqkey      = MoReSusHi_key(2)
      IF(MoReSusHi_key_SET(3)) qqkey      = MoReSusHi_key(3)
      IF(MoReSusHi_key_SET(7)) totLOkey   = MoReSusHi_key(7)
      IF(MoReSusHi_key_SET(8)) totNLOkey  = MoReSusHi_key(8)
      IF(MoReSusHi_key_SET(9)) totNNLOkey = MoReSusHi_key(9)      
c      IF(MoReSusHi_key_SET(10)) allAtOnce = MoReSusHi_key(10)      
c      IF(MoReSusHi_key_SET(12)) toploopkey= MoReSusHi_key(12)      
c      IF(MoReSusHi_key_SET(13)) botloopkey= MoReSusHi_key(13)      
      
com-- Block: SMINPUTS and MASS
      IF(SMinput_SET(1)) alpha = SMinput(1)
      IF(SMinput_SET(2)) gF    = SMinput(2)
c      IF(SMinput_SET(4)) mZ    = SMinput(4)
c      IF(SMinput_SET(5)) mb    = SMinput(5)
      IF(SMinput_SET(6)) mT    = SMinput(6)

      elw = 0d0
      if (ewkey.eq.1) then
         call elw_lq()
         elw = elw_sushi
      elseif (ewkey.eq.2) then
         if (pseudo.eq.36) then
            elw = 0.d0
         else
            elw = glgl_elw(mT,Hmass)
         endif
      endif

      CALL initPDFs()

com-- give info, warn and error messages, when variables are not set
      if(Scales_SET(4) .and. Scales_SET(5)) then
         CALL printstop('Block Scales entry 4 and 5 are set.'//
     f        ' You can only set either of them as input of Qres.')
      elseif(.not.Scales_SET(4) .and. .not.Scales_SET(5)) THEN
         write(tmp,'(F9.2)') Qres
         CALL printinfo('Block Scales entry 4 and 5 missing.'// 
     f   ' --> Using default: Qres='//tmp//'GeV.')
      ENDIF
      IF(.not.MoReSusHi_SET(1)) THEN         
         write(tmp,'(i8)') N
         CALL printinfo('Block MoReSusHi entry 1 missing.'// 
     f   ' --> Using default: N='//tmp)
      ENDIF
      IF(.not.SusHi_SET(4)) THEN
         CALL printstop('Block SusHi entry 4 missing.'//
     f   ' --> S_had not set.')
      ENDIF
      IF(.not.Scales_SET(2)) THEN
         write(tmp,'(F6.3)') muF/Hmass
         CALL printinfo('Block Scales entry 2 missing.'// 
     f   ' --> Using default: mu_F/m_H='//tmp)
      ENDIF
      IF(.not.Scales_SET(1)) THEN
         write(tmp,'(F6.3)') muRen/Hmass
         CALL printinfo('Block Scales entry 1 missing.'// 
     f   ' --> Using default: mu_R/m_H='//tmp)
      ENDIF
c$$$      IF(.not.MoReSusHi_SET(6)) THEN
c$$$         IF(order == 1) THEN
c$$$            CALL printinfo('Block MoReSusHi entry 6 missing.'// 
c$$$     f   ' --> Using default order= LO+NLO.')
c$$$         ELSEIF(order == 2) THEN
c$$$            CALL printinfo('Block MoReSusHi entry 6 missing.'// 
c$$$     f   ' --> Using default: order = NLO+NNLO.')
c$$$         ENDIF   
c$$$      ENDIF
      IF(.not.PDF_SET(1)) THEN
         CALL printinfo('Block PDFSPEC entry 1 missing.'// 
     f   ' --> Using default: LO-PDFs= '//prefixLO)
      ENDIF
      IF(.not.PDF_SET(2)) THEN
         CALL printinfo('Block PDFSPEC entry 2 missing.'// 
     f   ' --> Using default: NLO-PDFs= '//prefixNLO)
      ENDIF
      IF(.not.PDF_SET(3)) THEN
         CALL printinfo('Block PDFSPEC entry 3 missing.'// 
     f   ' --> Using default: NNLO-PDFs= '//prefixNNLO)
      ENDIF
      IF(.not.SusHi_SET(3)) THEN
         write(itmp,'(i2)') iset
         CALL printinfo('Block MoReSusHi entry 10 missing.'// 
     f   ' --> Using default: pp(Proton-Proton col.)='//itmp)
      ENDIF
      IF((.not.PDF_SET(10)).and.(.not.PDF_SET(12))) THEN
         write(itmp,'(i2)') iset
         CALL printinfo('Block PDFSPEC entry 10 missing.'// 
     f   ' --> Using default: iset(PDF member)='//itmp)
      ENDIF
c$$$      IF(.not.MoReSusHi_SET(11)) THEN
c$$$         CALL printinfo('Block MoReSusHi entry 11 missing.'// 
c$$$     f  ' --> Output will be written into default file: '//dataName)
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_SET(12)) THEN
c$$$         CALL printinfo('Block MoReSusHi entry 12 missing.'// 
c$$$     f   ' --> Log will be written into default file: '//dataLog)
c$$$      ENDIF
c$$$      IF(.not.distrib2_SET(2)) THEN
c$$$         write(tmp,'(EN10.2)') pT_Hmax
c$$$         CALL printinfo('Block DISTRIB2 entry 2 missing.'// 
c$$$     f  ' --> Using default:  pT_Hmax=sqrt(S_had)/2*(1-m_H**2/S_had)='
c$$$     f   //tmp//'(no cut).')
c$$$      ENDIF
c$$$      IF(.not.distrib2_SET(3)) THEN
c$$$         write(tmp,'(ES10.2)') y_Hmin
c$$$         CALL printinfo('Block DISTRIB2 entry 3 missing.'// 
c$$$     f   ' --> Using default:   y_Hmin=-ln(sqrt(S_had)/m_H)='
c$$$     f   //tmp//'(no cut).')
c$$$      ENDIF
c$$$      IF(.not.distrib2_SET(4)) THEN
c$$$         write(tmp,'(ES10.2)') y_Hmax
c$$$         CALL printinfo('Block DISTRIB2 entry 4 missing.'// 
c$$$     f   ' --> Using default:   y_Hmax= ln(sqrt(S_had)/m_H)='
c$$$     f   //tmp//'(no cut).')
c$$$      ENDIF      
      IF(.not.distrib2_SET(6) .or. pTH .le. 0d0) THEN
         bins = .true.
c$$$         CALL printinfo('Block DISTRIB2 entry 6 missing or set <=0 '
c$$$     f      //'--> Calculating distribution between pT_Hmin'// 
c$$$     f        ' and pT_Hmax with stepsize.')
         IF(.not.distrib2_SET(1)) THEN
            CALL printstop('Block DISTRIB2 entry 1 missing.'// 
     f           ' --> pT_Hmin not set.')
         ENDIF
         IF(.not.distrib2_SET(2)) THEN
            CALL printstop('Block DISTRIB2 entry 2 missing.'// 
     f           ' --> pT_Hmax not set.')
         ENDIF
         IF(.not.distrib2_SET(5)) THEN
            CALL printstop('Block DISTRIB2 entry 5 missing.'// 
     f           ' --> no stepsize set.')
         ENDIF
      ELSE
         bins = .false.
         write(tmp,'(ES10.2)') pTH
c$$$         IF(distrib2_SET(1) .or. distrib2_SET(2)) THEN
c$$$            CALL printinfo('Block DISTRIB2 entry 6 (pTH) set >0.'// 
c$$$     f           ' --> ignoring Block DISTRIB2 entry 1 (pT_min) '//
c$$$     f           'and 2 (pT_max), and calculating resummed cross '//
c$$$     f           'section just for pTH= '//tmp//'GeV.')
c$$$         ENDIF
      ENDIF

      IF(.not.MoReSusHi_key_SET(1)) THEN
         If(ggkey == 1) chan = 'on'
         If(ggkey == 0) chan = 'off'
         CALL printinfo('Block MoReSusHikeys entry 1 missing.'// 
     f   ' --> Using default: (gg)-channel= "'//chan//'".')
      ENDIF
      IF(.not.MoReSusHi_key_SET(2)) THEN
         If(gqkey == 1) chan = 'on'
         If(gqkey == 0) chan = 'off'
         CALL printinfo('Block MoReSusHikeys entry 2 missing.'// 
     f   ' --> Using default: gq-channel= "'//chan//'".')
      ENDIF
      IF(.not.MoReSusHi_key_SET(3)) THEN
         If(qqkey == 1) chan = 'on'
         If(qqkey == 0) chan = 'off'
         CALL printinfo('Block MoReSusHikeys entry 2 missing.'// 
     f   ' --> Using default: qq-channel= "'//chan//'".')
      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(7)) THEN
c$$$         If(totLOkey == 1) chan = 'on'
c$$$         If(totLOkey == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 7 missing.'// 
c$$$     f   ' --> Using default: total(LO)= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(8)) THEN
c$$$         If(totNLOkey == 1) chan = 'on'
c$$$         If(totNLOkey == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 8 missing.'// 
c$$$     f   ' --> Using default: total(NLO)= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(9)) THEN
c$$$         If(totNNLOkey == 1) chan = 'on'
c$$$         If(totNNLOkey == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 9 missing.'// 
c$$$     f   ' --> Using default: total(NNLO)= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(10)) THEN
c$$$         If(allAtOnce == 1) chan = 'on'
c$$$         If(allAtOnce == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 10 missing.'// 
c$$$     f   ' --> Using default: simultaneous integration= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(12)) THEN
c$$$         If(toploopkey == 1) chan = 'on'
c$$$         If(toploopkey == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 12 missing.'// 
c$$$     f   ' --> Using default: top-loop contribution= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.MoReSusHi_key_SET(13)) THEN
c$$$         If(botloopkey == 1) chan = 'on'
c$$$         If(botloopkey == 0) chan = 'off'
c$$$         CALL printinfo('Block MoReSusHikeys entry 13 missing.'// 
c$$$     f   ' --> Using default: bottom-loop contribution= "'//chan//'".')
c$$$      ENDIF
c$$$      IF(.not.SMinput_SET(1)) THEN
c$$$         write(tmp,'(F11.7)') 1d0/alpha
c$$$         CALL printinfo('Block SMinputs entry 1 missing.'// 
c$$$     f   ' --> Using default:    alpha^-1= '//tmp)
c$$$      ENDIF
      IF(.not.SMinput_SET(2)) THEN
         write(tmp,'(ES10.4)') gF
         CALL printinfo('Block SMinputs entry 2 missing.'// 
     f   ' --> Using default:    G_Fermi= '//tmp)
      ENDIF
      IF(.not.SMinput_SET(4)) THEN
         write(tmp,'(F7.4)') mZ
         CALL printinfo('Block SMinputs entry 4 missing.'// 
     f   ' --> Using default:    m_Z= '//tmp)
      ENDIF
      IF(.not.SMinput_SET(5)) THEN
         write(tmp,'(F6.3)') mb
         CALL printinfo('Block SMinputs entry 5 missing.'// 
     f   ' --> Using default:    mb(Pole)= '//tmp)
      ENDIF
      IF(.not.SMinput_SET(6)) THEN
         write(tmp,'(F8.3)') mT
         CALL printinfo('Block SMinputs entry 6 missing.'// 
     f   ' --> Using default:    mT(pole)= '//tmp)
      ENDIF

      y_symmetric = 1
      IF(dabs(y_Hmin) .ne. dabs(y_Hmax)) y_symmetric = 0
      END

C-}}}
C-{{{ dummy subroutine suinitpdf

      subroutine suinitpdf(order,pdfnamein,isetin)
      implicit none
      character pdfnamein*50
      integer order,isetin
      end

C-}}}
