! This file is part of MoRe-SusHi.
! 
! It includes the input and output routines of MoRe-SusHi.
! 
C-{{{ subroutine outputmoresushi

      subroutine outputmoresushi()

      implicit none

      integer date_time(8)
      character realcl(3)*12
      logical ppcoll,rscale
      character pdfnames(1:3)*50
      integer pdfset(1:3)

      include 'Commons/common-sushi.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-order.f'
      include 'Commons/common-output.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-chankeys.f'
      include 'Commons/common-scalesintvars.f'

      common /coll/ ppcoll

      open(unit=13,file=paramfile,status='unknown')

      call printcopymoresushi(0,13,verbosept)

      call date_and_time(realcl(1),realcl(2),realcl(3),date_time)

      write (13,106) date_time(3), date_time(2), date_time(1),
     &date_time(5), date_time(6), date_time(7)

      write(13,103)
     &"# For the reconstructed input file, check below.   #"
      write(13,103)
     &"#--------------------------------------------------#"
c$$$      if (ewkey.eq.1) then
c$$$         citations(11) = 1
c$$$         citations(12) = 1
c$$$      endif
c$$$      if (ewkey.eq.2) then
c$$$         citations(10) = 1
c$$$      endif
c$$$      citations(26) = 1
c$$$      citations(20) = 2
c$$$      citations(21) = 2
c$$$      citations(22) = 2

      ptcitations = 0
      ptcitations(1) = 1
      ptcitations(2) = 1
      ptcitations(3) = 1
      ptcitations(4) = 1
      ptcitations(5) = 1
      ptcitations(6) = 1
      ptcitations(7) = 1
      ptcitations(8) = 1
      write(13,"(a)")
     &"# Please cite the following papers (for this run):"
      call printcitept(13,1,'# ')
      write(13,103)
     &"#--------------------------------------------------#"

      write(13,103) 'Block MORESUSHIinfo'
      write(13,1023) 1,version,  'MoRe-SusHi version'
      write(13,1024) 2,SUversion,'SusHi version'
      if(fhflag) then
         write(13,1024) 3,fhvers,'FeynHiggs version'
      endif
      if(thdmcflag) then
         write(13,1024) 4,thdmcvers,'2HDMC version'
      endif
      write(13,102)  5,elw,"electroweak factor"

      call writecouplings()

      write(13,103)
     &     "#--------------------------------------------------#"
      write(13,103)
     &     "# Reconstructed input file of this run             #"
      write(13,103)
     &     "#--------------------------------------------------#"
      
      write(13,103) 'Block MORESUSHI'
      write(13,1031) 1,N,'Number of integrations'
      write(13,103) 'Block DISTRIB2'
      write(13,102)  1,pT_Hmin,'Minimal Higgs pT in GeV'
      write(13,102)  2,pT_Hmax,'Maximal Higgs pT in GeV'
      write(13,102)  5,stepsize,'Stepsize of Higgs pT in GeV'
      write(13,103) 'Block MORESUSHIKEYS'
      write(13,1020) 1,ggkey,'gluon-gluon channel: 0=off, 1=on'
      write(13,1020) 2,gqkey,'gluon-quark channel: 0=off, 1=on'
      write(13,1020) 3,qqkey,'quark-quark channel: 0=off, 1=on'
      write(13,1020) 11,htlkey,'heavy-top approximation: 0=off, 1=on'

      ppcoll=.false.
      if (pp.eq.1) ppcoll=.true.
      pdfnames(1)=prefixLO
      pdfnames(2)=prefixNLO
      pdfnames(3)=prefixNNLO
      pdfset(1)=iset
      pdfset(2)=iset
      pdfset(3)=iset
      rscale=.false.
      if(runscale.eq.1) rscale=.true.
      call writeinpfile(13,dsqrt(Shad),rscale,qres,muF/Hmass,pdfnames,
     &     pdfset)

      !call filedump(12,13)
      write(13,103)
     &"#--------------------------------------------------#"
      write(13,103) 
     &"# End of MoRe-SusHi output                           #"
      write(13,103)
     &"#--------------------------------------------------#"

      close(12)
      close(13)

 102  format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 1020 format(1x,I9,4x,1P,i2.1,0P,3x,'#',1x,A)
 1021 format(1x,I9,3x,1P,i6.1,0P,3x,'#',1x,A)
 1031 format(1x,I9,3x,1P,i8.1,0P,3x,'#',1x,A)
 1022 format(1x,I9,5x,1P,A45,0P,3x,'#',1x,A)
 1023 format(1x,I9,2x,1P,A10,0P,10x,'#',1x,A)
 1024 format(1x,I9,5x,1P,A10,0P,7x'#',1x,A)
 103  format(a)
 105  format('#--------------------------------------------------#')
 106  format ('# Date: ',i2.2,'.',i2.2,'.',i4.4,' at ',
     &i2.2,':',i2.2,':',i2.2,'                     #')
 107  format(9x,1P,E16.8,0P,3x,'#',1x,A)
 1070 format(9x,1P,i2.1,0P,3x,'#',1x,A)
 108  format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)

      end

C-}}}
C-{{{ subroutine printcopymoresushi:

      subroutine printcopymoresushi(fullflag,iu,verbose_local)

      integer fullflag, iu, verbose_local

      include 'Commons/common-output.f'

      if (verbose_local.ne.0) then
         write(iu,1)
     &"#--------------------------------------------------#"
         write(iu,1)
     &"# MoRe-SusHi: Resummed transverse momentum         #"
         write(iu,1)
     &"# distributions of supersymmetric Higgs bosons     #"
         write(iu,1)
     &"#      _  _   __   _   _      __      __           #"
         write(iu,1)
     &"#     | \/ | |  | |_| |_  _  [_  | | [_  |_| |     #"
         write(iu,1)
     &"#     |    | |__| | \ |_     __] |_| __] | | |     #"
         write(iu,1)
     &"#                                                  #"
         write(iu,1)
     &"# Mo(mentum) Re(summed) Su(per)s(ymmetric) Hi(ggs) #"
!         write(iu,1)
!     &"#                                                  #"
         write(iu,1)
     &"# Version "//version//date
     &//"                    #"
         if (fullflag.eq.1) then
            write(iu,1)
     &"# H. Mantler                    (hmantler@cern.ch) #"
            write(iu,1)
     &"# M. Wiesemann            (dr.wiesemann@gmail.com) #"
            write(iu,1)
     &"#--------------------------------------------------#"
            write(iu,1)
     &"# MoRe-SusHi is based on a number of calculations  #"
            write(iu,1)
     &"# due to various groups. Please acknowledge these  #"
            write(iu,1)
     &"# efforts by citing the list of references which   #"
            write(iu,1)
     &"# are included in the output file of every run.    #"
         end if
         write(iu,1)
     &"#--------------------------------------------------#"
      endif

 1    format(a)
      end

C-}}}
C-{{{ SUBROUTINE ParameterOUTandERR:

      SUBROUTINE ParameterOUTandERR()
      implicit none
      DOUBLE PRECISION dsqrtS_had2
      CHARACTER tmp1*2,tmp2*2,tmp3*14,tmp4*7,tmp5*7,tmp6*13,tmp7*13
      include 'Commons/common-output.f'
      include 'Commons/common-order.f'
      include 'Commons/common-cplngs.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-results.f'
      include 'Commons/common-chankeys.f'

      if(verbosept.ne.0) then
c$$$      IF(htlkey == 0) THEN
c$$$      write(*,*) '                >>>  '//
c$$$     f   '(exact top mass dependence)  <<<         '
c$$$      write(40,*)'                >>>  '//
c$$$     f   '(exact top mass dependence)  <<<         '
c$$$      ELSEIF(htlkey == 1) THEN
c$$$      write(*,*) '                >>> '//
c$$$     f   ' ( heavy-top approximation )  <<<         '
c$$$      write(40,*)'                >>> '//
c$$$     f   ' ( heavy-top approximation )  <<<         '
c$$$      ELSE
c$$$         write(tmp1,'(i2)') order
c$$$         CALL printstop('bad parameter: "order = '//tmp1//'" not '
c$$$     f    //'accepted value')
c$$$      ENDIF
      write(*,*) ' '
      write(40,*)' '

 3333 FORMAT(A25,F8.2,A)
 3332 FORMAT(A25,1X,A7)
 2222 FORMAT(A25,F7.2)
 2221 FORMAT(A25,2X,I2.2)
 2223 FORMAT(A25,I8)
      write(*,*) '         ---====    Parameter    ====---'
      write(40,*)'         ---====    Parameter    ====---'
      dsqrtS_had2=dsqrt(Shad)/1000d0
      write (*, 3333) '-\|S_had`= ', dsqrtS_had2, ' TeV'
      write (*, 3333) 'm_H      = ', Hmass, ' GeV'
      write (*, 3333) 'mu_F     = ', muF, ' GeV'
      write (*, 3333) 'mu_R     = ', muRen, ' GeV'
      write (*, 3333) 'Q_res    = ', Qres, ' GeV'
      write (*, 2221) 'PDF-Set  = ', iset
      write(40, 3333) '-\|S_had`= ', dsqrtS_had2, ' TeV'
      write(40, 3333) 'm_H      = ', Hmass, ' GeV'
      write(40, 3333) 'mu_F     = ', muF, ' GeV'
      write(40, 3333) 'mu_R     = ', muRen, ' GeV'
      write(40, 3333) 'Q_res    = ', Qres, ' GeV'
      write(40, 2221) 'PDF-Set  = ', iset
c$$$      IF(pTH .ne. 0d0) THEN
c$$$         write (*, 3333) 'pT_H        = ', pTH, ' GeV'
c$$$         write (40, 3333) 'pT_H        = ', pTH, ' GeV'
c$$$      ENDIF
      write (*, 2223) 'N_int    = ', N
      write(40, 2223) 'N_int    = ', N

      write(*,*) '         ---====   pT - binning  ====---'
      write(40,*)'         ---====   pT - binning  ====---'

      IF(pT_Hmin > pT_Hmax) THEN
         CALL printstop('bad cuts: pT_Hmin > pT_Hmax not possible'
     f   //'            choose: pT_Hmin < pT_Hmax' )
      ENDIF
      IF(y_Hmin > y_Hmax) THEN
         CALL printstop('bad cuts: y_Hmin > y_Hmax not possible'
     f   //'              choose: y_Hmin < y_Hmax' )
      ENDIF
      IF(pT_Hmin > dsqrt(Shad)/2d0*(1-Hmass**2/Shad)) THEN
         write(tmp3,'(F9.2,A5)') pT_Hmin,' GeV"'
         write(tmp4,'(F7.2)') dsqrt(Shad)/2d0*(1-Hmass**2/Shad)
      CALL printstop('bad cut: "pT_Hmin ='//tmp3//
     f ' cuts everything,  choose: "pT_Hmin < '//tmp4//' GeV" for' 
     f //' used m_H,S_had')
      ENDIF
      IF(pT_Hmax < 0d0) THEN
         write(tmp3,'(F9.2,A5)') pT_Hmax,' GeV"'
      CALL printstop('bad cut: "pT_Hmax ='//tmp3//
     f ' cuts everything,  choose: "pT_Hmax > 0.00 GeV"')
      ENDIF
      IF(y_Hmin > dlog(dsqrt(Shad)/Hmass)) THEN
         write(tmp4,'(F6.2,A1)') y_Hmin,'"' 
         write(tmp5,'(F6.2,A1)') dlog(dsqrt(Shad)/Hmass),'"'
      CALL printstop('bad cut: "y_Hmin ='//tmp4//
     f ' cuts everything,          choose: "y_Hmin <'//tmp5//' for' 
     f //' used m_H,S_had')
      ENDIF
      IF(y_Hmax < -dlog(dsqrt(Shad)/Hmass)) THEN
         write(tmp4,'(F6.2,A1)') y_Hmax,'"' 
         write(tmp5,'(F6.2,A1)') -dlog(dsqrt(Shad)/Hmass),'"'
      CALL printstop('bad cut: "y_Hmax ='//tmp4//
     f ' cuts everything,          choose: "y_Hmax >'//tmp5//' for' 
     f //' used m_H,S_had')
      ENDIF
      IF(bins) THEN
      IF(pT_Hmin > 0d0) THEN
         write (*, 3333) 'pT_Hmin  = ', pT_Hmin, ' GeV'
         write(40, 3333) 'pT_Hmin  = ', pT_Hmin, ' GeV'
      ENDIF
      IF(pT_Hmax < dsqrt(Shad)/2d0*(1-Hmass**2/Shad)) THEN
         write (*, 3333) 'pT_Hmax  = ', pT_Hmax, ' GeV'
         write(40, 3333) 'pT_Hmax  = ', pT_Hmax, ' GeV'
      ENDIF
      IF(stepsize > 0d0) THEN
         write (*, 3333) 'stepsize = ', stepsize, ' GeV'
         write(40, 3333) 'stepsize = ', stepsize, ' GeV'
      ENDIF
      ELSE
      write(*,*) 'no pT - binning'
      write(40,*)'no pT - binning'
      ENDIF
      endif

      write(*,*) ' '
      write(40,*) ' '
      write(*,*)  '      >>>       Start calculation       '//
     f'<<<'
      write(40,*) '      >>>       Start calculation       '//
     f'<<<'
      write(*,*)  '      >>>   Resummed pT-distribution    '//
     f         '<<<         '
      write(40,*) '      >>>   Resummed pT-distribution    '//
     f         '<<<'

      IF(order == 1) THEN
      write(*,*) '      >>>  '//
     f   '        at NLO+NLL           <<<'
      write(40,*)'      >>>  '//
     f   '        at NLO+NLL           <<<'
      ELSEIF(order == 2) THEN
      write(*,*) '      >>> '//
     f   '       at NNLO+NNLL          <<<'
      write(40,*)'      >>> '//
     f   '       at NNLO+NNLL          <<<'
      ELSE
         write(tmp1,'(i2)') order
         CALL printstop('bad parameter: "order = '//tmp1//'" not '
     f    //'accepted value')
      ENDIF

      write(*,*) ' '
      write(40,*)' '
      END

C-}}}
