      SUBROUTINE resumINT(N,resumLO,errLO,resumNLO,errNLO)
      implicit none
      DOUBLE PRECISION resumLO,resumNLO,errLO,errNLO
      include 'Commons/common-cuts.f'
      INTEGER N,ndim,ncall,ncall1,itmx,nprn,itmx1
      double precision XL,XU,acc,chi2,y(10)
      COMMON/BVEG1/XL(10),XU(10),acc,ndim,ncall,itmx,nprn
      external resumedLO

      resumLO=0d0
      resumNLO=0d0
      errLO=0d0
      errNLO=0d0
      
      XL(1) = 0.00000000001d0
      XL(2) = y_Hmin
      XL(3) = pT_Hmin**2
      XU(1) = 1d0
      XU(2) = y_Hmax
      XU(3) = pT_Hmax**2    ! XL = X(lower), XU = X(upper)

      acc = -1d0
      nprn = 0       ! set how much info vegas give (try 1 or -1)
      ndim = 2

      print*,' '
      print*, '#############        RESUMATION        #################'
      print*, ' '

      itmx = 6      ! iterations and number of events
      ncall = 30000    ! in each iteration
      itmx1 = 8
      ncall1 = N*10

      call vegas(resumedLO,resumLO,errLO,chi2)
      itmx=itmx1
      ncall = ncall1
      call vegas1(resumedLO,resumLO,errLO,chi2)

      print*, 'resum(LO)=     ',resumLO,'  +/-',errLO
      print*,' '

      END
     
      DOUBLE PRECISION FUNCTION resumedLO_dpTdy(x)
      implicit none
      DOUBLE PRECISION x(10),resumedLO_bb
      include 'Commons/common-cuts.f'
      resumedLO_dpTdy=0d0
      x(2)=pT_Hmin**2
      x(3)=y_Hmin
      
      resumedLO_dpTdy=resumedLO_bb(x)
      END
     
      DOUBLE PRECISION FUNCTION resumedLO_bg(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb
      COMMON /x0ax0b/ x0_a,x0_b
      
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLO_bg=0d0
      
      pT2=x(2)
      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(3))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(3))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)
      
      IF(pT2 > pT_cut**2) RETURN
!       (Shad+Hmass**2)**2/(4d0*Shad*dcosh(x(3))**2)-Hmass**2)
!      f RETURN 

      call initrescoeff2()

      C1_0=0d0
      
!       C1_0=B1*PDFs + P_bbf_bb(x(1)) + P_gbf_gb(x(1))
!      f + f_bbP_bb(x(1)) + f_bgP_gb(x(1))
      C1_0= P_gbf_gb(x(1)) + f_bgP_gb(x(1))
      
!       C1_0=B1*PDFs + P_bbf_bb(x(1)) + f_bbP_bb(x(1))
      
      
!       C1_1=A1*PDFs
      C1_1=0d0

      resumedLO_bg=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
     f ( C1_0 /pT2 + C1_1 /pT2 * dlog(Hmass**2/pT2)) * GeVpb
      END
      
      DOUBLE PRECISION FUNCTION resumedLO_bb(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLO_bb=0d0
      
      pT2=x(2)
      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(3))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(3))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)
      
      IF(pT2 > pT_cut**2) RETURN
!       (Shad+Hmass**2)**2/(4d0*Shad*dcosh(x(3))**2)-Hmass**2)
!      f RETURN 

      call initrescoeff2()

      C1_0=0d0
      
!       C1_0=B1*PDFs + P_bbf_bb(x(1)) + f_bbP_bb(x(1))
!      f + P_gbf_gb(x(1)) + f_bgP_gb(x(1))
!       C1_0= P_gbf_gb(x(1)) + f_bgP_gb(x(1))
      
      C1_0=B1*PDFs+ P_bbf_bb(x(1)) + f_bbP_bb(x(1))
!       C1_0=P_bbf_bb(x(1))
      
      C1_1=A1*PDFs
	!       C1_1=0d0

      resumedLO_bb=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
     f ( C1_0 /pT2 + C1_1 /pT2 * dlog(Hmass**2/pT2)) * GeVpb
      END
      
      DOUBLE PRECISION FUNCTION resumedLO(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLO=0d0

      x(3)=x(2)

      pT2 = pTH**2
      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(3))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(3))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)
!      IF(pT2 > pT_cut**2) RETURN
!       (Shad+Hmass**2)**2/(4d0*Shad*dcosh(x(3))**2)-Hmass**2)
!      f RETURN 

      call initrescoeff2()

      C1_0=0d0
! bbbar      
!      C1_0=B1*PDFs + P_bbf_bb(x(1)) + f_bbP_bb(x(1))
! bbbar
      C1_0 = + P_gbf_gb(x(1)) + f_bgP_gb(x(1))
      C1_1 = 0d0
! bbbar       
!      C1_1=A1*PDFs
! bbbar
      resumedLO=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
     f ( C1_0 /pT2 + C1_1 /pT2 * dlog(Hmass**2/pT2)) * GeVpb * 2d0 *pTH
      END
      
      DOUBLE PRECISION FUNCTION resumedNLO(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C2_0,C2_1,C2_2,C2_3,
     f PDFs,PDFsbbbar,x0_a,x0_b,Sigma_0,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb,
     f C_bbf_bb,f_bbC_bb,C_gbf_gb,f_bgC_gb,
     f P_bbf_bPbbf_b,P_bbPbbf_bb,f_bbP_bbPbb,
     f P_gbf_gPbbf_b,P_bbf_bPgbf_g
      COMMON /x0ax0b/ x0_a,x0_b
      
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedNLO=0d0
      
      pT2=x(2)
      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(3))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(3))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)
      
      IF(pT2 > pT_cut**2) RETURN
!       (Shad+Hmass**2)**2/(4d0*Shad*dcosh(x(3))**2)-Hmass**2)
!      f RETURN 

      call initrescoeff2()
      
      C2_0=B1*PDFs + P_bbf_bb(x(1)) + P_gbf_gb(x(1))
     f + f_bbP_bb(x(1)) + f_bgP_gb(x(1))
      
      C2_1=(beta0-2d0*B1-A1*dlog(muF**2/Hmass**2))           ! bb-chan 
     f                      * (P_bbf_bb(x(1)) + f_bbP_bb(x(1)))
     f    + A1 * (C_bbf_bb(x(1))+f_bbC_bb(x(1)))
     f    -P_bbf_bPbbf_b(x(1))-P_bbf_bPbbf_b(x(1))
     f    -P_bbPbbf_bb(x(1))-f_bbP_bbPbb(x(1))
     f    +(beta0-2d0*B1-A1*dlog(muF**2/Hmass**2))           ! bg-chan
     f                      * (P_gbf_gb(x(1)) + f_bgP_gb(x(1)))
     f    + A1 * (C_gbf_gb(x(1)) + f_bgC_gb(x(1)))
     f    -P_gbf_gPbbf_b(x(1))-P_bbf_bPgbf_g(x(1))
     f    -P_gbf_gPbbf_b(x(1))-P_bbf_bPgbf_g(x(1))
     
      
      C2_2=-3d0/2d0*A1*(P_bbf_bb(x(1)) + f_bbP_bb(x(1)))     ! bb-chan
     f     +A1*(beta0-3d0/2d0*B1)*PDFs
     f     -3d0/2d0*A1*(P_gbf_gb(x(1)) + f_bgP_gb(x(1)))     ! bg-chan

      C2_3=-A1**2/2d0*PDFs                                   ! bb-chan
      
      resumedNLO=Sigma_0*Hmass**2/Shad*(alpha_s(order)/(2*Pii))**2 *
     f ( C2_0 /pT2 + C2_1 /pT2 * dlog(Hmass**2/pT2) + C2_2 /pT2 *
     f  dlog(Hmass**2/pT2)**2+C2_3 /pT2 * dlog(Hmass**2/pT2)**3) * GeVpb
      END

      
      DOUBLE PRECISION FUNCTION resumedLOadd_bg(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,f_bgP_gb_ep,P_gbf_gb_ep,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb,C1_0_ep
      COMMON /x0ax0b/ x0_a,x0_b
      
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLOadd_bg=0d0

      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(2))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(2))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)

      call initrescoeff2()

      C1_0=0d0
      C1_0= P_gbf_gb(x(1)) + f_bgP_gb(x(1))
      C1_0_ep= P_gbf_gb_ep(x(1)) + f_bgP_gb_ep(x(1))

      C1_1=0d0

      resumedLOadd_bg=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
     f (-C1_0_ep-C1_0 * (dlog(muRen**2/pT_cut**2)))
     f * GeVpb
!       resumedLOadd_bg=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
!      f ( -C1_0_ep+(-C1_0 + C1_1 * dlog(pT_cut**2/Hmass**2)
!      f + C1_1/2d0 * dlog(muRen**2/pT_cut**2)) *
!      f dlog(muRen**2/pT_cut**2))
!      f * GeVpb
      END

      DOUBLE PRECISION FUNCTION resumedLOadd_bb(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,f_bbP_bb_ep,P_bbf_bb_ep,
     f P_bbf_bb,f_bbP_bb,C1_0_ep,fit
      COMMON /x0ax0b/ x0_a,x0_b
      
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLOadd_bb=0d0

      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(2))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(2))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)

      call initrescoeff2()

      C1_0=0d0
      C1_1=0d0
      
      C1_0=B1*PDFs + P_bbf_bb(x(1)) + f_bbP_bb(x(1))
      C1_0_ep= P_bbf_bb_ep(x(1)) + f_bbP_bb_ep(x(1))
      
      fit= - 4d0/3d0 * Pii**2/6d0 * PDFs
!       C1_0_ep=C1_0_ep*2d0
!       C1_0= P_gbf_gb(x(1)) + f_bgP_gb(x(1))
!       C1_0_ep= P_gbf_gb_ep(x(1)) + f_bgP_gb_ep(x(1))
      

      C1_1=A1*PDFs
!      f =dsqrt((Shad+Hmass**2)**2/(4d0*Shad*dcosh(x(2))**2)-Hmass**2)
      
!       resumedLOadd=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
!      f ( C1_0 * dlog(pT_Hmax**2/muRen**2)
!      f + C1_1 *(-dlog(pT_Hmax**2)**2/2d0
!      f +dlog(pT_Hmax**2)*dlog(Hmass**2)))
!      f * GeVpb

      
      resumedLOadd_bb=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2d0*Pii) *
     f ( -C1_0_ep + fit +(-C1_0 + C1_1 * dlog(pT_cut**2/Hmass**2)
     f + C1_1/2d0 * dlog(muRen**2/pT_cut**2)) *
     f dlog(muRen**2/pT_cut**2))
     f * GeVpb
      END

      DOUBLE PRECISION FUNCTION resumedLOadd(x)
      implicit none
      DOUBLE PRECISION x(10),Hbb,alpha_s,pT2,yvar,C1_0,C1_1,Cvars,PDFs,
     f PDFsbbbar,x0_a,x0_b,Sigma_0,f_bgP_gb_ep,P_gbf_gb_ep,
     f P_bbf_bb,f_bbP_bb,P_gbf_gb,f_bgP_gb,C1_0_ep
      COMMON /x0ax0b/ x0_a,x0_b
      
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      resumedLOadd=0d0

      
      x0_a=Hmass/dsqrt(Shad)*dexp(x(2))
      x0_b=Hmass/dsqrt(Shad)*dexp(-x(2))

      Sigma_0=Pii/6d0*Hbb(order)/Hmass**2
      PDFs=PDFsbbbar(x0_a,x0_b,muF,order)

      call initrescoeff2()

      C1_0=0d0
      
!       C1_0=B1*PDFs + P_bbf_bb(x(1)) + P_gbf_gb(x(1))
!      f + f_bbP_bb(x(1)) + f_bgP_gb(x(1))
      C1_0= P_gbf_gb(x(1)) + f_bgP_gb(x(1))
      C1_0_ep= P_gbf_gb_ep(x(1)) + f_bgP_gb_ep(x(1))
      
!       C1_0=B1*PDFs + P_bbf_bb(x(1)) + f_bbP_bb(x(1))
      
      
!       C1_1=A1*PDFs
      C1_1=0d0

      resumedLOadd=Sigma_0*Hmass**2/Shad*alpha_s(order)/(2*Pii) *
     f ( -C1_0_ep+(-C1_0 + C1_1 * dlog(pT_cut**2/Hmass**2)
     f + C1_1/2d0 * dlog(muRen**2/pT_cut**2)) *
     f dlog(muRen**2/pT_cut**2))
     f * GeVpb
      END

      DOUBLE PRECISION FUNCTION P_bbf_bb(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_bbf_bb=P_qq(z)*(PDFsbbbar(x0_a/z,x0_b,muF,order)/z
     f * theta(z,x0_a)  - PDFsbbbar(x0_a,x0_b,muF,order))
      END

      DOUBLE PRECISION FUNCTION f_bbP_bb(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bbP_bb=P_qq(z)*(PDFsbbbar(x0_a,x0_b/z,muF,order)/z
     f * theta(z,x0_b) - PDFsbbbar(x0_a,x0_b,muF,order))
      END

      DOUBLE PRECISION FUNCTION P_gbf_gb(z)
      implicit none
      DOUBLE PRECISION z,PDFsgb,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_gbf_gb=P_gq(z)*PDFsgb(x0_a/z,x0_b,muF,order)/z
     f * theta(z,x0_a)
      END
      
      DOUBLE PRECISION FUNCTION f_bgP_gb(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bgP_gb=P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
     f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION P_gbf_gb_ep(z)
      implicit none
      DOUBLE PRECISION z,PDFsgb,x0_a,x0_b,theta,P_gq
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_gbf_gb_ep=(-1d0*z*(1-z))*PDFsgb(x0_a/z,x0_b,muF,order)/z
     f * theta(z,x0_a)
!       P_gbf_gb_ep=-1d0/2d0*P_gq(z)*PDFsgb(x0_a/z,x0_b,muF,order)/z
!      f * theta(z,x0_a)
      END
      
      DOUBLE PRECISION FUNCTION f_bgP_gb_ep(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,x0_a,x0_b,theta,P_gq
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bgP_gb_ep=(-1d0*z*(1-z))*PDFsbg(x0_a,x0_b/z,muF,order)/z
     f * theta(z,x0_b)
!       f_bgP_gb_ep=-1d0/2d0*P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION P_bbf_bb_ep(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-constants.f'
      P_bbf_bb_ep=-cF*(1-z)
     f * PDFsbbbar(x0_a/z,x0_b,muF,order)/z * theta(z,x0_a)
      END

      DOUBLE PRECISION FUNCTION f_bbP_bb_ep(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-constants.f'
      f_bbP_bb_ep=-cF*(1-z)
     f * PDFsbbbar(x0_a,x0_b/z,muF,order)/z * theta(z,x0_b)
      END

      DOUBLE PRECISION FUNCTION C_bbf_bb(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      C_bbf_bb=0d0!P_qq(z)*(PDFsbbbar(x0_a/z,x0_b,muF,order)/z
!      f * theta(z,x0_a)  - PDFsbbbar(x0_a,x0_b,muF,order))
      END

      DOUBLE PRECISION FUNCTION f_bbC_bb(z)
      implicit none
      DOUBLE PRECISION z,x0_a,x0_b,P_qq,PDFsbbbar,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bbC_bb=0d0!P_qq(z)*(PDFsbbbar(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b) - PDFsbbbar(x0_a,x0_b,muF,order))
      END

      DOUBLE PRECISION FUNCTION C_gbf_gb(z)
      implicit none
      DOUBLE PRECISION z,PDFsgb,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      C_gbf_gb=0d0!P_gq(z)*PDFsgb(x0_a/z,x0_b,muF,order)/z
!      f * theta(z,x0_a)
      END
      
      DOUBLE PRECISION FUNCTION f_bgC_gb(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bgC_gb=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END

      DOUBLE PRECISION FUNCTION P_bbf_bPbbf_b(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_bbf_bPbbf_b=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION P_bbPbbf_bb(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_bbPbbf_bb=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION f_bbP_bbPbb(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      f_bbP_bbPbb=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION P_gbf_gPbbf_b(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_gbf_gPbbf_b=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END
      
      DOUBLE PRECISION FUNCTION P_bbf_bPgbf_g(z)
      implicit none
      DOUBLE PRECISION z,PDFsbg,P_gq,x0_a,x0_b,theta
      COMMON /x0ax0b/ x0_a,x0_b
      include 'Commons/common-order.f'
      include 'Commons/common-scalesintvars.f'
      P_bbf_bPgbf_g=0d0!P_gq(z)*PDFsbg(x0_a,x0_b/z,muF,order)/z
!      f * theta(z,x0_b)
      END


      SUBROUTINE initrescoeff2()
      implicit none
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      
      A1=2d0*cF
      A2=2d0*cF*((67d0/18d0-Pii**2/6d0)*cA-50d0/9d0*tR)
      B1=-3d0*cF
      B2=1d0
      END

