      SUBROUTINE slharead_pt(iunit)
com--
com-- Read SLHA Input file and set local parameters
com--     
      CHARACTER blocks(20)*15
      INTEGER nkeys(20)
      DOUBLE PRECISION default1,default2
      CHARACTER defstring1*20,defstring2*20
      include 'Commons/common-slha.f'

      DO i=1,20
         blocks(i) = ' '
      ENDDO

      blocks(1) = 'MoReSusHi'
      blocks(2) = 'DISTRIB2'
      blocks(3) = 'MoReSusHikeys'
      blocks(4) = 'SusHi'
      blocks(5) = 'SMinputs'
      blocks(6) = 'Mass'
      blocks(7) = 'Scales'
      blocks(8) = 'PDFSPEC'

      do i=1,20
         MoReSusHi_SET(i) = .false.
         distrib2_SET(i) = .false.
         MoReSusHi_key_SET(i) = .false.
         SusHi_SET(i) = .false.
         SMinput_SET(i) = .false.
         massBo_SET(i) = .false.
         Scales_SET(i) = .false.
         PDF_SET(i) = .false.
      enddo

      CALL readblocks_pt(iunit,blocks,nkeys)
      
      DO i=1,5
         IF(nkeys(i).eq.1) THEN
c$$$            CALL printinfo('Block '//blocks(i)//' found.')
         ELSE
            CALL printinfo('Block '//blocks(i)//' not found.')
         ENDIF
      ENDDO

com-- mandatory blocks:
c$$$      IF( nkeys(1) == 0 ) THEN
c$$$         CALL printstop('Block MoReSusHi not found')
c$$$      ENDIF

com-- mandatory entries:
c$$$      IF( .not. SETtestvars(5)) THEN
c$$$         CALL printstop('Block MoReSusHi entry 5 is missing')
c$$$      ENDIF
c$$$ 
c$$$      IF( .not. SETstringvars(12)) THEN
c$$$         CALL printstop('Block MoReSusHi entry 12 is missing')
c$$$      ENDIF
c$$$
c$$$      print*, '--------- sonst --------'
c$$$      print*, 'nr 1 : ', MoReSusHi_var(1)      
c$$$      print*, 'nr 2 : ', MoReSusHi_var(2)      
c$$$      print*, 'nr 3 : ', MoReSusHi_var(3)      
c$$$      print*, 'nr 4 : ', MoReSusHi_var(4)      
c$$$      print*, 'nr 5 : ', MoReSusHi_var(5)      
c$$$      print*, 'nr 6 : ', MoReSusHi_int(6)      
c$$$      print*, 'nr 7 : ', MoReSusHi_str(7)      
c$$$      print*, 'nr 8 : ', MoReSusHi_str(8)      
c$$$      print*, 'nr 9 : ', MoReSusHi_str(9)      
c$$$      print*, 'nr10 : ', MoReSusHi_int(10)      
c$$$      print*, 'nr11 : ', MoReSusHi_str(11)      
c$$$      print*, 'nr12 : ', MoReSusHi_str(12)      
c$$$      print*, 'nr13 : ', MoReSusHi_str(13)      
c$$$      print*, 'nr20 : ', MoReSusHi_int(20)      
c$$$      print*, 'nr21 : ', MoReSusHi_int(21)      
c$$$      print*, 'nr22 : ', MoReSusHi_int(22)      
c$$$      print*, 'nr23 : ', MoReSusHi_var(23)     
c$$$
c$$$      print*, '--------- cuts --------'      
c$$$      print*, 'nr 1 : ', MoReSusHi_cut(1)      
c$$$      print*, 'nr 2 : ', MoReSusHi_cut(2)      
c$$$      print*, 'nr 3 : ', MoReSusHi_cut(3)      
c$$$      print*, 'nr 4 : ', MoReSusHi_cut(4)      
c$$$      print*, 'nr11 : ', MoReSusHi_cut(11)      
c$$$      print*, 'nr12 : ', MoReSusHi_cut(12)      
c$$$      print*, 'nr13 : ', MoReSusHi_cut(13)      
c$$$      print*, 'nr14 : ', MoReSusHi_cut(14)      
c$$$      print*, 'nr21 : ', MoReSusHi_cut(21)      
c$$$      print*, 'nr22 : ', MoReSusHi_cut(22)      
c$$$      print*, 'nr23 : ', MoReSusHi_cut(23)     
c$$$      print*, 'nr24 : ', MoReSusHi_cut(24)     
c$$$      
c$$$      print*, '--------- keys --------'      
c$$$      print*, 'bb : ', MoReSusHi_key(1)      
c$$$      print*, 'bg : ', MoReSusHi_key(2)      
c$$$      print*, 'bb : ', MoReSusHi_key(3)      
c$$$      print*, 'qb : ', MoReSusHi_key(4)      
c$$$      print*, 'gg : ', MoReSusHi_key(5)      
c$$$      print*, 'qq : ', MoReSusHi_key(6)      
c$$$      print*, 'totLO   : ', MoReSusHi_key(7)      
c$$$      print*, 'totNLO  : ', MoReSusHi_key(8)      
c$$$      print*, 'totNNLO : ', MoReSusHi_key(9)      
c$$$      
c$$$      print*, '--------- mass --------'      
c$$$      print*, 'nr 25 (m_H): ', massBo(25)      
c$$$      print*, 'nr 2  (G_F): ', SMinput(2)      
c$$$      print*, 'nr 3  (m_Z): ', SMinput(4)      
c$$$      print*, 'nr 5  (m_b): ', SMinput(5)      
c$$$      
      
      END


c$$$      subroutine printslha(unit)
c$$$c..
c$$$c..   Provide output in SLHA format.
c$$$c..   File with UNIT=unit should be opened before call.
c$$$c..
c$$$      implicit real*8(a-h,o-z)
c$$$      integer unit
c$$$      include 'commons/common-slha.f'
c$$$      include 'commons/common-sigma.f'
c$$$      include 'commons/common-vars.f'
c$$$      include 'commons/common-keys.f'
c$$$      include 'commons/common-params.f'
c$$$      include 'commons/common-consts.f'
c$$$      include 'commons/common-vegpar.f'
c$$$      include 'commons/common-outstr.f'
c$$$      include 'commons/common-errors.f'
c$$$
c$$$      sminputs(2) = gfermi
c$$$      sminputs(3) = apimz*pi
c$$$      sminputs(4) = mz
c$$$      sminputs(5) = mbmb
c$$$
c$$$      call slhamap
c$$$
c$$$      call printnotice(unit)
c$$$
c$$$      write(unit,2001) '#--------------------------------'
c$$$      write(unit,2001) '# output of bbh@nnlo:'
c$$$      write(unit,2001) '#--------------------------------'
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK SMINPUTS'
c$$$      write(unit,2002) 2,sminputs(2),csminputs(2)
c$$$      write(unit,2002) 4,sminputs(4),csminputs(4)
c$$$      write(unit,2002) 5,sminputs(5),csminputs(5)
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK MASS'
c$$$      write(unit,2002) 25,mh,csmassbo(25)
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK CREIN'
c$$$      write(unit,2002) 7,rmurmh,cslhacrein(7)
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK HNNLO1'
c$$$      write(unit,2003) 1,norder,chiggsnnlo1(1)
c$$$      write(unit,2003) 3,higgsnnlo1(3),chiggsnnlo1(3)
c$$$      write(unit,2003) 5,npdfstart,'start PDF'
c$$$      write(unit,2003) 6,npdfend,'end PDF'
c$$$      write(unit,2003) 10,nsubprocess,chiggsnnlo1(10)
c$$$      if (lsloppy) then
c$$$         write(unit,2003) 11,1,chiggsnnlo1(11)
c$$$      else
c$$$         write(unit,2003) 11,0,chiggsnnlo1(11)
c$$$      endif
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK HNNLO2'
c$$$      write(unit,2002) 1,sqrts,chiggsnnlo2(1)
c$$$      write(unit,2002) 4,rmufmh,chiggsnnlo2(4)
c$$$      write(unit,2002) 5,gb,chiggsnnlo2(5)
c$$$      write(unit,2002) 7,mbmuR,'mb(muR)'
c$$$      write(unit,2002) 10,apimz*pi,'alphas(Mz)'
c$$$
c$$$      write(unit,2000)
c$$$      write(unit,2001) 'BLOCK HNNLOSIGMA'
c$$$      if (warning.ne.0) then
c$$$         write(unit,2001)
c$$$     &        '# bbh@nnlo has produced a WARNING '
c$$$      endif
c$$$      write(unit,2002) 0,apimuR*pi,'alpha_s(muR)'
c$$$      write(unit,2002) 1,sigma(norder),'sigma [pb]'
c$$$c..      write(unit,2002) 2,sigerr(norder),'+/- delta(sigma) [pb]'
c$$$      write(unit,2002) 3,rho0,'rho0 [pb]'
c$$$      write(unit,2002) 10,sigma(0),'sigma(0) [pb]'
c$$$      if (norder.ge.1) then
c$$$         write(unit,2002) 11,sigma(1),'sigma(1) [pb]'
c$$$      endif
c$$$      if (norder.ge.2) then
c$$$         write(unit,2002) 12,sigma(2),'sigma(2) [pb]'
c$$$      endif
c$$$      if (norder.ge.3) then
c$$$         write(unit,2002) 13,sigma(3),'sigma(3) [pb]'
c$$$      endif
c$$$      if (norder.ge.4) then
c$$$         write(unit,2002) 14,sigma(4),'sigma(4) [pb]'
c$$$      endif
c$$$
c$$$      write(unit,2001) '#--------------------------------'
c$$$      write(unit,2001) '# END of bbh@nnlo output'
c$$$      write(unit,2001) '#--------------------------------'
c$$$
c$$$ 2000 format('#')
c$$$ 2001 format(A)
c$$$ 2002 format(1x,i4,1x,e16.9,3x,'#',1x,a)
c$$$ 2003 format(1x,i2,1x,i2,0p,3x,'#',1x,a)
c$$$ 2004 format(1x,i2,2x,a,0p,3x,'#',1x,a)
c$$$
c$$$      end
c$$$
c$$$
c$$$
c$$$C-{{{ DESC:
c$$$
c$$$c..   slhablocks.f  is part of bbh@nnlo
c$$$c..   See README for a description of this package.
c$$$
c$$$C-}}}
c$$$C-{{{ RCS:
c$$$
c$$$c..   $Id: slhablocks.f,v 1.4 2005/05/23 13:03:12 rharland Exp $
c$$$c..   $Log: slhablocks.f,v $
c$$$c..   Revision 1.4  2005/05/23 13:03:12  rharland
c$$$c..   'lsloppy' switch included
c$$$c..   PDF sets can be included without LHAPDF (see Notepad 2004/3, page 127)
c$$$c..
c$$$c..   Revision 1.3  2005/02/01 10:17:27  rharland
c$$$c..   before taking out LHAPDF again
c$$$c..
c$$$c..   Revision 1.1  2004/11/16 11:54:37  rharland
c$$$c..   Initial revision
c$$$c..
c$$$
c$$$C-}}}
c$$$C-{{{ subroutine slhamap:
c$$$
c$$$      subroutine slhamap
c$$$c..
c$$$c..   Map the SLHA identification codes to names.
c$$$c..   For example: 
c$$$c..   csmassbo(25) = 'M(h)'
c$$$c..   i.e., smassbo(25) contains the mass of the light Higgs.
c$$$c..   
c$$$      include 'commons/common-slha.f'
c$$$      include 'commons/common-keys.f'
c$$$
c$$$c..   fill with empty string:
c$$$      do i=1,20
c$$$         write(csminputs(i),3001)
c$$$         write(csmassbo(i),3001)
c$$$         write(chiggsnnlo1(i),3001)
c$$$         write(chiggsnnlo2(i),3001)
c$$$      enddo
c$$$
c$$$      csminputs(1) = '1/alphaQED(Mz)'
c$$$      csminputs(2) = 'GFermi'
c$$$      csminputs(3) = 'alpha_s(Mz)'
c$$$      csminputs(4) = 'Mz'
c$$$      csminputs(5) = 'mb(mb)'
c$$$      csminputs(6) = 'Mt(pole)'
c$$$      csminputs(7) = 'Mtau'
c$$$
c$$$      csmassbo(25) = 'h0'
c$$$      
c$$$      chiggsnnlo1(1)  = '[0: LO] [1: NLO] [2: NNLO]'
c$$$      chiggsnnlo1(2)  = '[0: scalar] [1: pseudo-scalar]'
c$$$      chiggsnnlo1(3)  = '[0: p-p] [1: p-pbar]'
c$$$      chiggsnnlo1(7)  = '[0: SM] [1: other model] [2: C1=1]'
c$$$      chiggsnnlo1(10) = '0:all/1:bbar/2:bg/3:gg/4:bb/5:bq/6:qqb'
c$$$      chiggsnnlo1(11) = '[0: strict] [1: sloppy]'
c$$$
c$$$      chiggsnnlo2(1) = 'sqrt(s)'
c$$$      chiggsnnlo2(2) = 'Mh'
c$$$      cslhacrein(7) = 'muR/Mh'
c$$$      chiggsnnlo2(4) = 'muF/Mh'
c$$$      chiggsnnlo2(5) = 'y_b'
c$$$      chiggsnnlo2(6) = 'y_t'
c$$$      chiggsnnlo2(10) = 'alpha_s(Mz)'
c$$$
c$$$      ctopcoup(1) = 'gth'
c$$$      cbotcoup(1) = 'gbh'
c$$$      ctopcoup(11) = 'gth11'
c$$$      ctopcoup(21) = 'gth21'
c$$$      ctopcoup(12) = 'gth12'
c$$$      ctopcoup(22) = 'gth22'
c$$$
c$$$ 3001 format(40a)
c$$$      
c$$$      end
c$$$
c$$$C-}}}
